{$A+,B-,D-,E-,F+,G+,I-,L-,N+,O-,R-,S-,V-}

UNIT Maths;


INTERFACE

(*$IFOPT N-*)

TYPE RealType=REAL;

(*$ELSE*)

TYPE RealType=Single;

(*$ENDIF*)


CONST maxSpline=30;
      maxBSpline2D=30;
      maxBSpline3D=400;

      c05:    RealType=0.5000000000;
      c20:    RealType=2.0000000000;
      cRez255:RealType=0.003921568627450980;

      Infinite:RealType=1E30;
      PiDiv180:RealType=Pi/180;
      c180DivPi:RealType=180/Pi;
      PiMul2:RealType=2*Pi;
      PiDiv2:RealType=Pi/2;
      PiMul3Div2:RealType=Pi*3/2;

      sin0 :RealType=0.0000000000;
      sin10:RealType=0.1736481777;
      sin20:RealType=0.3420201433;
      sin30:RealType=0.5000000000;
      sin40:RealType=0.6427876097;
      sin45:RealType=0.7071067812;
      sin50:RealType=0.7660444431;
      sin60:RealType=0.8660254038;
      sin70:RealType=0.9396926208;
      sin80:RealType=0.9848077530;
      sin90:RealType=1.0000000000;

      cos0 :RealType=1.0000000000;
      cos10:RealType=0.9848077530;
      cos20:RealType=0.9396926208;
      cos30:RealType=0.8660254038;
      cos40:RealType=0.7660444431;
      cos45:RealType=0.7071067812;
      cos50:RealType=0.6427876097;
      cos60:RealType=0.5000000000;
      cos70:RealType=0.3420201433;
      cos80:RealType=0.1736481777;
      cos90:RealType=0.0000000000;


TYPE
     Spline=            (* Konstruktion zum Aufbau eines Splines *)
         RECORD
             cnt,PREDcnt:WORD;
             l,r,rl2,mrl,l2,rml2:RealType;
             dd1,dd2,nx1,ny1,nx2,ny2:RealType;
             mina,maxa:RealType;
             a:ARRAY[0..maxSpline] OF
                   RECORD
                       y,ddl:RealType
                   END
         END;



     BSpline2D=        (* 2D B-Spline  *)
         RECORD
             n:INTEGER;
             P:ARRAY[0..maxBSpline2D] OF RECORD
                 x,y:RealType;
             END
         END;

     BSpline3D=        (* 3D B-Spline  *)
         RECORD
             n,m,succn:INTEGER;
             P:ARRAY[0..maxBSpline3D] OF RECORD
                 x,y,z:RealType;
             END
         END;



(*** Funktionen, die nicht zum Sprachumfang von      ***)
(*** Pascal gehren:                                 ***)
FUNCTION ArcSin(x:RealType):RealType;

FUNCTION ArcCos(x:RealType):RealType;

FUNCTION Tan(x:RealType):RealType;

FUNCTION Cot(x:RealType):RealType;

FUNCTION ArcCot(x:RealType):RealType;


FUNCTION Power(a,b:RealType):RealType;

PROCEDURE kreuz(x1,x2,x3,
                y1,y2,y3:RealType;
                VAR z1,z2,z3:RealType);
(*** Kreuzprodukt.                                   ***)

PROCEDURE Normalize(VAR x,y,z:RealType);
(*** Normalisiert den Vektor. 0-Vektor bleibt        ***)

FUNCTION max2(x1,x2:RealType):RealType;
FUNCTION max3(x1,x2,x3:RealType):RealType;
FUNCTION max4(x1,x2,x3,x4:RealType):RealType;
(*** Maximum ber 2,3 oder 4 Zahlen.                 ***)


FUNCTION min2(x1,x2:RealType):RealType;
FUNCTION min3(x1,x2,x3:RealType):RealType;
FUNCTION min4(x1,x2,x3,x4:RealType):RealType;
(*** Minimum ber 2,3 oder 4 Zahlen.                 ***)


FUNCTION max2I(x1,x2:LONGINT):LONGINT;
FUNCTION max3I(x1,x2,x3:LONGINT):LONGINT;
FUNCTION max4I(x1,x2,x3,x4:LONGINT):LONGINT;
(*** Maximum ber 2,3 oder 4 Integer-Zahlen.         ***)


FUNCTION min2I(x1,x2:LONGINT):LONGINT;
FUNCTION min3I(x1,x2,x3:LONGINT):LONGINT;
FUNCTION min4I(x1,x2,x3,x4:LONGINT):LONGINT;
(*** Minimum ber 2,3 oder 4 Integer-Zahlen.         ***)


PROCEDURE DefineSpline(VAR s:Spline;r:RealType;cnt:WORD);
(*** Initalisiere Spline: r definiert das Intervall, ***)
(*** in dem die Funktion gltig ist: [-r,r]; cnt     ***)
(*** gibt an, wieviele Sttzstellen angegeben werden.***)


PROCEDURE DefineSplinePoint(VAR s:Spline;ind:WORD;y:RealType);
(*** Definiere Funktionswert mit dem Index           ***)
(***   i:0..PRED(cnt)                                ***)


FUNCTION GetSplineX(VAR s:Spline;ind:WORD):RealType;
(*** Ermittelt zu einem Index gem DefineSplinePoint***)
(*** einen X-Wert.                                   ***)


PROCEDURE GetSplineF(VAR s:Spline;x:RealType;VAR y,nx,ny:RealType);
(*** Ermittelt den Funktionswert an der Stelle       ***)
(*** x:[-r,r] anhand des definierten Splines. Auer- ***)
(*** dem wird die Normale auf dem Punkt berechnet.   ***)
(*** x auerhalb von [-r,r] wird auf den ersten bzw  ***)
(*** letzten Wert des Splines abgebildet.            ***)


PROCEDURE DefineBSpline2D(VAR BS:BSpline2D;nn:INTEGER);
(*** Definiert einen 2D B-Spline. Sttzpunkte von    ***)
(*** 0..nn mssen definiert werden.                  ***)

PROCEDURE DefineBSpline2DPoint(VAR BS:BSpline2D;i:INTEGER;xx,yy:RealType);
(*** Definiert einen Sttzpunkt (i aus 0..nn).       ***)

PROCEDURE GetBSpline2D(VAR BS:BSpline2D;u:RealType;VAR rx,ry:RealType);
(*** Berechnet einen Spline-Punkt (u aus 0..1).      ***)
(*** rx,ry Ergebnis.                                 ***)

PROCEDURE DefineBSpline3D(VAR BS:BSpline3D;nn,mm:INTEGER);
(*** Definiert einen 3D B-Spline. Sttzpunkte von    ***)
(*** 0..nn,0..mm mssen definiert werden.            ***)

PROCEDURE DefineBSpline3DPoint(VAR BS:BSpline3D;i,j:INTEGER;xx,yy,zz:RealType);
(*** Definiert einen Sttzpunkt (i aus 0..nn, j aus  ***)
(*** 0..mm).                                         ***)

PROCEDURE GetBSpline3D(VAR BS:BSpline3D;u,v:RealType;VAR rx,ry,rz:RealType);
(*** Berechnet einen Spline-Punkt (u aus 0..1,v aus  ***)
(*** 0..1). rx,ry,rz Ergebnis.                       ***)

PROCEDURE GetBSpline3DNorm(VAR BS:BSpline3D;u,v:RealType;VAR rx,ry,rz,nx,ny,nz:RealType);
(*** Berechnet einen Spline-Punkt und Normale .      ***)
(*** (u aus 0..1,v aus 0..1). rx,ry,rz Ergebnis.     ***)
(*** nx,ny,nz Normale (Lnge 1)                      ***)

PROCEDURE lgs(a11,a12,a13,c1,
              a21,a22,a23,c2,
              a31,a32,a33,c3:RealType;
              VAR x1,x2,x3:RealType;
              VAR err:BOOLEAN);
(*** Lst ein lineares Glechungssystem mit drei      ***)
(*** Unbekannten. Die Matrix wird in aii, ci berge- ***)
(*** ben, die Lsung steht in xi. Ist das System un- ***)
(*** lsbar, so ist err gesetzt.                     ***)


PROCEDURE lgs2(a11,a12,c1,
              a21,a22,c2:RealType;
              VAR x1,x2:RealType;
              VAR err:BOOLEAN);
(*** Analog zu lgs, nur mit zwei unbekannten.        ***)

FUNCTION OwnRandom:RealType;
(*** Erzeugt eine Zufallszahl 0<=x<1 in immer dersel-***)
(*** ben Reihenfolge nach jedem Programmlauf         ***)


FUNCTION Between(nr,lowBorder,highBorder:RealType):BOOLEAN;
(*** Ist wahr, wenn die nr sich innerhalb der Gren-  ***)
(*** zen befindet.                                   ***)


FUNCTION Lin(a1,a2,r:RealType):RealType;
FUNCTION BiLin(a11,a12,a21,a22,r1,r2:RealType):RealType;
FUNCTION TriLin(a111,a112,a121,a122,a211,a212,a221,a222,r1,r2,r3:RealType):RealType;
(*** Lineare, Bilineare, Trilineare Interpolation.   ***)



IMPLEMENTATION
CONST epsilon=1e-9;
      seedCnt1=17;
      seedCnt2=23;
      seedCnt3=11;

CONST RandNumb1:ARRAY[0..seedCnt1-1] OF RealType=
           (0.1394789353,
            0.3002700063,
            0.5297498049,
            0.9837496832,
            0.5361311600,
            0.4413011439,
            0.6418657120,
            0.0226059744,
            0.6208777515,
            0.5177419257,
            0.1227691372,
            0.8027067364,
            0.5551165187,
            0.8025760423,
            0.5457455789,
            0.1306674757,
            0.4299732730);
      RandNumb2:ARRAY[0..seedCnt2-1] OF RealType=
           (0.1962659345,
            0.6267695823,
            0.8796531741,
            0.5592637685,
            0.8020092675,
            0.5768012188,
            0.2901379301,
            0.7802428476,
            0.4949556019,
            0.2545716057,
            0.4763501115,
            0.9249685845,
            0.1929329801,
            0.1808626787,
            0.8889594180,
            0.5770793509,
            0.2183631151,
            0.3140368589,
            0.4600281760,
            0.1878301808,
            0.1506323898,
            0.5026081989,
            0.1959207840);


VAR seed1,seed2,seed3:BYTE;
    RandSum:RealType;


PROCEDURE kreuz(x1,x2,x3,
                y1,y2,y3:RealType;
                VAR z1,z2,z3:RealType);
BEGIN
     z1:=x2*y3-x3*y2;
     z2:=x3*y1-x1*y3;
     z3:=x1*y2-x2*y1
END;


PROCEDURE Normalize(VAR x,y,z:RealType);
VAR l:RealType;
BEGIN
    l:=Sqrt(Sqr(x)+Sqr(y)+Sqr(z));
    IF l>epsilon THEN
    BEGIN
        l:=1/l;
        x:=x*l;
        y:=y*l;
        z:=z*l
    END
END;


FUNCTION ArcSin(x:RealType):RealType;
BEGIN
    IF ABS(x)<1 THEN
        ArcSin:=ArcTan(x/Sqrt(1-Sqr(x)))
    ELSE IF x=1 THEN
        ArcSin:=Pi/2
    ELSE
        ArcSin:=-Pi/2
END;


FUNCTION ArcCos(x:RealType):RealType;
BEGIN
    IF x>0 THEN
        ArcCos:=ArcTan(Sqrt(1-Sqr(x))/x)
    ELSE IF x<0 THEN
        ArcCos:=Pi+ArcTan(Sqrt(1-Sqr(x))/x)
    ELSE
        ArcCos:=Pi/2
END;


FUNCTION Tan(x:RealType):RealType;
BEGIN
    Tan:=Sin(x)/Cos(x)
END;


FUNCTION Cot(x:RealType):RealType;
BEGIN
    Cot:=Cos(x)/Sin(x)
END;


FUNCTION ArcCot(x:RealType):RealType;
BEGIN
    ArcCot:=PiDiv2-ArcTan(x)
END;


FUNCTION Power(a,b:RealType):RealType;
BEGIN
    Power:=Exp(Ln(a)*b)
END;


FUNCTION max2(x1,x2:RealType):RealType;
BEGIN
    IF x1>x2 THEN
        max2:=x1
    ELSE
        max2:=x2
END;


FUNCTION max3(x1,x2,x3:RealType):RealType;
BEGIN
    IF x1>x2 THEN
    BEGIN
        IF x1>x3 THEN
            max3:=x1
        ELSE
            max3:=x3
    END
    ELSE BEGIN
        IF x2>x3 THEN
            max3:=x2
        ELSE
            max3:=x3
    END
END;


FUNCTION max4(x1,x2,x3,x4:RealType):RealType;
BEGIN
    IF x1>x2 THEN
    BEGIN
        IF x1>x3 THEN
        BEGIN
            IF x1>x4 THEN
                max4:=x1
            ELSE
                max4:=x4
        END
        ELSE BEGIN
            IF x3>x4 THEN
                max4:=x3
            ELSE
                max4:=x4
        END
    END
    ELSE BEGIN
        IF x2>x3 THEN
        BEGIN
            IF x2>x4 THEN
                max4:=x2
            ELSE
                max4:=x4
        END
        ELSE BEGIN
            IF x3>x4 THEN
                max4:=x3
            ELSE
                max4:=x4
        END
    END
END;


FUNCTION min2(x1,x2:RealType):RealType;
BEGIN
    IF x1<x2 THEN
        min2:=x1
    ELSE
        min2:=x2
END;


FUNCTION min3(x1,x2,x3:RealType):RealType;
BEGIN
    IF x1<x2 THEN
    BEGIN
        IF x1<x3 THEN
            min3:=x1
        ELSE
            min3:=x3
    END
    ELSE BEGIN
        IF x2<x3 THEN
            min3:=x2
        ELSE
            min3:=x3
    END
END;


FUNCTION min4(x1,x2,x3,x4:RealType):RealType;
BEGIN
    IF x1<x2 THEN
    BEGIN
        IF x1<x3 THEN
        BEGIN
            IF x1<x4 THEN
                min4:=x1
            ELSE
                min4:=x4
        END
        ELSE BEGIN
            IF x3<x4 THEN
                min4:=x3
            ELSE
                min4:=x4
        END
    END
    ELSE BEGIN
        IF x2<x3 THEN
        BEGIN
            IF x2<x4 THEN
                min4:=x2
            ELSE
                min4:=x4
        END
        ELSE BEGIN
            IF x3<x4 THEN
                min4:=x3
            ELSE
                min4:=x4
        END
    END
END;


FUNCTION max2I(x1,x2:LONGINT):LONGINT;
BEGIN
    IF x1>x2 THEN
        max2I:=x1
    ELSE
        max2I:=x2
END;


FUNCTION max3I(x1,x2,x3:LONGINT):LONGINT;
BEGIN
    IF x1>x2 THEN
    BEGIN
        IF x1>x3 THEN
            max3I:=x1
        ELSE
            max3I:=x3
    END
    ELSE BEGIN
        IF x2>x3 THEN
            max3I:=x2
        ELSE
            max3I:=x3
    END
END;


FUNCTION max4I(x1,x2,x3,x4:LONGINT):LONGINT;
BEGIN
    IF x1>x2 THEN
    BEGIN
        IF x1>x3 THEN
        BEGIN
            IF x1>x4 THEN
                max4I:=x1
            ELSE
                max4I:=x4
        END
        ELSE BEGIN
            IF x3>x4 THEN
                max4I:=x3
            ELSE
                max4I:=x4
        END
    END
    ELSE BEGIN
        IF x2>x3 THEN
        BEGIN
            IF x2>x4 THEN
                max4I:=x2
            ELSE
                max4I:=x4
        END
        ELSE BEGIN
            IF x3>x4 THEN
                max4I:=x3
            ELSE
                max4I:=x4
        END
    END
END;


FUNCTION min2I(x1,x2:LONGINT):LONGINT;
BEGIN
    IF x1<x2 THEN
        min2I:=x1
    ELSE
        min2I:=x2
END;


FUNCTION min3I(x1,x2,x3:LONGINT):LONGINT;
BEGIN
    IF x1<x2 THEN
    BEGIN
        IF x1<x3 THEN
            min3I:=x1
        ELSE
            min3I:=x3
    END
    ELSE BEGIN
        IF x2<x3 THEN
            min3I:=x2
        ELSE
            min3I:=x3
    END
END;


FUNCTION min4I(x1,x2,x3,x4:LONGINT):LONGINT;
BEGIN
    IF x1<x2 THEN
    BEGIN
        IF x1<x3 THEN
        BEGIN
            IF x1<x4 THEN
                min4I:=x1
            ELSE
                min4I:=x4
        END
        ELSE BEGIN
            IF x3<x4 THEN
                min4I:=x3
            ELSE
                min4I:=x4
        END
    END
    ELSE BEGIN
        IF x2<x3 THEN
        BEGIN
            IF x2<x4 THEN
                min4I:=x2
            ELSE
                min4I:=x4
        END
        ELSE BEGIN
            IF x3<x4 THEN
                min4I:=x3
            ELSE
                min4I:=x4
        END
    END
END;





PROCEDURE DefineSpline(VAR s:Spline;r:RealType;cnt:WORD);
VAR i:WORD;
BEGIN
    s.cnt:=cnt;
    s.r:=r;
    s.l:=2*r/PRED(cnt);
    s.rl2:=r+s.l/2;
    s.mrl:=-s.r+s.l;
    s.l2:=s.l/2;
    s.rml2:=s.r-s.l2;
    s.PREDcnt:=PRED(s.cnt);
    s.maxa:=-1e10;
    s.mina:=1e10;
    FOR i:=0 TO s.PREDcnt DO
        s.a[i].y:=0
END;


PROCEDURE DefineSplinePoint(VAR s:Spline;ind:WORD;y:RealType);

    PROCEDURE Makenn(dd:RealType;VAR nx,ny:RealType);
    BEGIN
        IF ABS(dd)<epsilon THEN
        BEGIN
            nx:=0;
            ny:=1
        END
        ELSE IF dd>0 THEN
        BEGIN
            nx:=-1;
            ny:=1/dd
        END
        ELSE BEGIN
            nx:=1;
            ny:=-1/dd
        END
    END;

BEGIN
    WITH s DO
    BEGIN
        a[ind].y:=y;
        IF y>maxa THEN
            maxa:=y;
        IF y<mina THEN
            mina:=y;
        IF ind>0 THEN
            a[PRED(ind)].ddl:=(a[ind].y-a[PRED(ind)].y)/l;
        IF ind<PREDcnt THEN
            a[ind].ddl:=(a[SUCC(ind)].y-a[ind].y)/l;
        dd1:=a[0].ddl;
        Makenn(dd1,nx1,ny1);
        dd2:=a[cnt-2].ddl;
        Makenn(dd2,nx2,ny2)
    END
END;


FUNCTION GetSplineX(VAR s:Spline;ind:WORD):RealType;
BEGIN
    GetSplineX:=ind*s.l-s.r
END;


PROCEDURE GetSplineF(VAR s:Spline;x:RealType;VAR y,nx,ny:RealType);
VAR ind1,ind2:INTEGER;
    fi,y1,y2,dd:RealType;
BEGIN
    WITH s DO
    BEGIN
        IF x<-r THEN
        BEGIN
            y:=a[0].y;
            nx:=0;
            ny:=1
        END
        ELSE IF x>r THEN
        BEGIN
            y:=a[PREDcnt].y;
            nx:=0;
            ny:=1
        END
        ELSE BEGIN
            ind2:=TRUNC((x+rl2)/l);
            ind1:=PRED(ind2);
            IF ind1<0 THEN
            BEGIN
                y:=a[0].y+dd1*(x+r);
                nx:=nx1;
                ny:=ny1
            END
            ELSE IF ind2>=PREDcnt THEN
            BEGIN
                y:=a[cnt-2].y+dd2*(x+mrl);
                nx:=nx2;
                ny:=ny2
            END
            ELSE BEGIN
                fi:=(x+rml2-ind1*l)/2;
                y1:=a[ind1].y+a[ind1].ddl*(fi+l2);
                y2:=a[ind2].y+a[ind2].ddl*fi;
                dd:=(y2-y1)/l2;
                y:=y1+dd*fi;
                IF ABS(dd)<epsilon THEN
                BEGIN
                    nx:=0;
                    ny:=1
                END
                ELSE IF dd>0 THEN
                BEGIN
                    nx:=-1;
                    ny:=1/dd
                END
                ELSE BEGIN
                    nx:=1;
                    ny:=-1/dd
                END
            END
        END
    END
END;


(*$IFOPT N-*)

PROCEDURE lgs(a11,a12,a13,c1,
              a21,a22,a23,c2,
              a31,a32,a33,c3:RealType;
              VAR x1,x2,x3:RealType;
              VAR err:BOOLEAN);
VAR d1,d2,d3,d4,d5,d6,d:RealType;

BEGIN
    d1:=a22*a33-a23*a32;
    d2:=a23*a31-a21*a33;
    d3:=a21*a32-a22*a31;
    d:=a11*d1+a12*d2+a13*d3;
    IF ABS(d)<1e-8 THEN
        err:=TRUE
    ELSE BEGIN
        err:=FALSE;
        d4:=c3*a23-c2*a33;
        d5:=c3*a22-c2*a32;
        d6:=c3*a21-c2*a31;
        x1:=(c1*d1+a12*d4-a13*d5)/d;
        x2:=(c1*d2+a13*d6-a11*d4)/d;
        x3:=(c1*d3+a11*d5-a12*d6)/d
    END
END;

(*$ELSE*)

PROCEDURE lgs(a11,a12,a13,c1,
              a21,a22,a23,c2,
              a31,a32,a33,c3:RealType;
              VAR x1,x2,x3:RealType;
              VAR err:BOOLEAN);
VAR d:RealType;
    status:WORD;
LABEL DIV0,noErr;
BEGIN
    ASM                 (*  ST  |  1   |  2   |  3   |  4   |  5   |  6   |  7   *)
        FLD a21         (* a21  |      |      |      |      |      |      |      *)
        FLD a22         (* a22  | a21  |      |      |      |      |      |      *)
        FLD a23         (* a23  | a22  | a21  |      |      |      |      |      *)
        FLD a31         (* a31  | a23  | a22  | a21  |      |      |      |      *)
        FLD a32         (* a32  | a31  | a23  | a22  | a21  |      |      |      *)
        FLD a33         (* a33  | a32  | a31  | a23  | a22  | a21  |      |      *)
        FLD ST          (* a33  | a33  | a32  | a31  | a23  | a22  | a21  |      *)
        FMUL ST,ST(5)   (*a33a22|      |      |      |      |      |      |      *)
        FLD ST(4)       (* a23  |a33a22| a33  | a32  | a31  | a23  | a22  | a21  *)
        FMUL ST,ST(3)   (*a23a32|      |      |      |      |      |      |      *)
        FSUBP ST(1),ST  (* d1   | a33  | a32  | a31  | a23  | a22  | a21  |      *)
        FSTP ST(7)      (* a33  | a32  | a31  | a23  | a22  | a21  | d1   |      *)
        FMUL ST,ST(5)   (*a33a21|      |      |      |      |      |      |      *)
        FXCH ST(3)      (* a23  |      |      |a33a21|      |      |      |      *)
        FMUL ST,ST(2)   (*a23a31|      |      |      |      |      |      |      *)
        FSUB ST,ST(3)   (* d2   |      |      |      |      |      |      |      *)
        FXCH ST(5)      (* a21  |      |      |      |      | d2   |      |      *)
        FMULP ST(1),ST  (*a32a21| a31  |a33a21| a22  | d2   | d1   |      |      *)
        FXCH ST(3)      (* a22  |      |      |a32a21|      |      |      |      *)
        FMULP ST(1),ST  (*a31a22|a33a21|a32a21| d2   | d1   |      |      |      *)
        FSUBR ST,ST(2)  (* d3   |      |      |      |      |      |      |      *)
        FSTP ST(5)      (*a33a21|a32a21| d2   | d1   | d3   |      |      |      *)
        FLD a11         (* a11  |a33a21|a32a21| d2   | d1   | d3   |      |      *)
        FMUL ST,ST(4)   (*a11d1 |      |      |      |      |      |      |      *)
        FLD a12         (* a12  |a11d1 | xxx  | xxx  | d2   | d1   | d3   |      *)
        FMUL ST,ST(4)   (*a12d2 |      |      |      |      |      |      |      *)
        FLD a13         (* a13  |a12d2 |a11d1 | xxx  | xxx  | d2   | d1   | d3   *)
        FMUL ST,ST(7)   (*a13d3 |      |      |      |      |      |      |      *)
        FADD            (* +    |a11d1 | xxx  | xxx  | d2   | d1   | d3   |      *)
        FADD            (* d    | xxx  | xxx  | d2   | d1   | d3   |      |      *)
        FTST
        FSTSW status   
        FWAIT          
        MOV AX,status
        SAHF
        JE Div0

                        (*  ST  |  1   |  2   |  3   |  4   |  5   |  6   |  7   *)
        FSTP d          (* xxx  | xxx  | d2   | d1   | d3   |      |      |      *)
        FINCSTP         (* xxx  | d2   | d1   | d3   |      |      |      |      *)
        FINCSTP         (* d2   | d1   | d3   |      |      |      |      |      *)
        FFREE ST(7)
        FFREE ST(6)
        FLD c1          (* c1   | d2   | d1   | d3   |      |      |      |      *)
        FMUL ST(1),ST   (*      | d2'  |      |      |      |      |      |      *)
        FMUL ST(2),ST   (*      |      | d1'  |      |      |      |      |      *)
        FMULP ST(3),ST  (* d2'  | d1'  | d3'  |      |      |      |      |      *)
        FLD c2          (* c2   | d2'  | d1'  | d3'  |      |      |      |      *)
        FLD c3          (* c3   | c2   | d2'  | d1'  | d3'  |      |      |      *)
        FLD a23         (* a23  | c3   | c2   | d2'  | d1'  | d3'  |      |      *)
        FMUL ST,ST(1)   (*a23c3 |      |      |      |      |      |      |      *)
        FLD a33         (* a33  |a23c3 | c3   | c2   | d2'  | d1'  | d3'  |      *)
        FMUL ST,ST(3)   (*a33c2 |      |      |      |      |      |      |      *)
        FSUBP ST(1),ST  (* d4   | c3   | c2   | d2'  | d1'  | d3'  |      |      *)
        FLD a22         (* a22  | d4   | c3   | c2   | d2'  | d1'  | d3'  |      *)
        FMUL ST,ST(2)   (*a22c3 |      |      |      |      |      |      |      *)
        FLD a32         (* a32  |a22c3 | d4   | c3   | c2   | d2'  | d1'  | d3'  *)
        FMUL ST,ST(4)   (*a32c2 |      |      |      |      |      |      |      *)
        FSUBP ST(1),ST  (* d5   | d4   | c3   | c2   | d2'  | d1'  | d3'  |      *)
        FLD a21         (* a21  | d5   | d4   | c3   | c2   | d2'  | d1'  | d3'  *)
        FMULP ST(3),ST  (* d5   | d4   |a21c3 | c2   | d2'  | d1'  | d3'  |      *)
        FLD a31         (* a31  | d5   | d4   |a21c3 | c2   | d2'  | d1'  | d3'  *)
        FMULP ST(4),ST  (* d5   | d4   |a21c3 |a31c2 | d2'  | d1'  | d3'  |      *)
        FXCH ST(2)      (*a21c3 |      | d5   |      |      |      |      |      *)
        FSUB ST,ST(3)   (* d6   |      |      |      |      |      |      |      *)
                        (*  ST  |  1   |  2   |  3   |  4   |  5   |  6   |  7   *)
        FSTP ST(3)      (* d4   | d5   | d6   | d2'  | d1'  | d3'  |      |      *)
        FLD a12         (* a12  | d4   | d5   | d6   | d2'  | d1'  | d3'  |      *)
        FMUL ST,ST(1)   (*a12d4 |      |      |      |      |      |      |      *)
        FADDP ST(5),ST  (* d4   | d5   | d6   | d2'  |  +   | d3'  |      |      *)
        FLD a13         (* a13  | d4   | d5   | d6   | d2'  |  +   | d3'  |      *)
        FMUL ST,ST(2)   (*a13d5 |      |      |      |      |      |      |      *)
        FSUBP ST(5),ST  (* d4   | d5   | d6   | d2'  | x1'  | d3'  |      |      *)
        FLD d           (* d    | d4   | d5   | d6   | d2'  | x1'  | d3'  |      *)
        FXCH ST(5)      (* x1'  |      |      |      |      | d    |      |      *)
        FDIV ST,ST(5)   (* x1   |      |      |      |      |      |      |      *)
        LES DI,x1       (* d4   | d5   | d6   | d2'  | d    | d3'  |      |      *)
        FSTP DWORD PTR ES:[DI]
        FLD a11         (* a11  | d4   | d5   | d6   | d2'  | d    | d3'  |      *)
        FMUL ST(1),ST   (*      |a11d4 |      |      |      |      |      |      *)
        FSTP ST(7)      (*a11d4 | d5   | d6   | d2'  | d    | d3'  | a11  |      *)
        FSUBP ST(3),ST  (* d5   | d6   |  -   | d    | d3'  | a11  |      |      *)
        FLD a13         (* a13  | d5   | d6   |  -   | d    | d3'  | a11  |      *)
        FMUL ST,ST(2)   (*a13d6 |      |      |      |      |      |      |      *)
        FADD ST,ST(3)   (* x2'  |      |      |      |      |      |      |      *)
        FDIV ST,ST(4)   (* x2   |      |      |      |      |      |      |      *)
        LES DI,x2       (* d5   | d6   | xxx  | d    | d3'  | a11  |      |      *)
        FSTP DWORD PTR ES:[DI]
        FMULP ST(5),ST  (* d6   | xxx  | d    | d3'  |a11d5 |      |      |      *)
        FLD a12         (* a12  | d6   | xxx  | d    | d3'  |a11d5 |      |      *)
        FMULP ST(1),ST  (*a12d6 | xxx  | d    | d3'  |a11d5 |      |      |      *)
        FSUBP ST(3),ST  (* xxx  | d    |  -   |a11d5 |      |      |      |      *)
        FXCH ST(3)      (*a11d5 |      |      | xxx  |      |      |      |      *)
        FADDP ST(2),ST  (* d    | x3'  | xxx  |      |      |      |      |      *)
        FDIVP ST(1),ST  (* x3   | xxx  |      |      |      |      |      |      *)
        FFREE ST(1)     (* x3   |      |      |      |      |      |      |      *)
        LES DI,x3       (*      |      |      |      |      |      |      |      *)
        FSTP DWORD PTR ES:[DI]
        XOR AX,AX
        JMP noErr
   DIV0:FFREE ST(5)
        FFREE ST(4)
        FFREE ST(3)
        FFREE ST(2)
        FFREE ST(1)
        FFREE ST
        MOV AX,1
  noErr:LES DI,err
        MOV BYTE PTR ES:[DI],AL
        WAIT
    END
END;

(*$ENDIF*)


(*$IFOPT N-*)

PROCEDURE lgs2(a11,a12,c1,
              a21,a22,c2:RealType;
              VAR x1,x2:RealType;
              VAR err:BOOLEAN);
VAR d:RealType;
BEGIN
    d:=a21*a12-a22*a11;
    IF ABS(d)<1e-8 THEN
        err:=TRUE
    ELSE BEGIN
        err:=FALSE;
        x2:=(c1*a21-c2*a11)/d;
        x1:=(c2*a12-c1*a22)/d
    END
END;

(*$ELSE*)

PROCEDURE lgs2(a11,a12,c1,
              a21,a22,c2:RealType;
              VAR x1,x2:RealType;
              VAR err:BOOLEAN);
VAR status:WORD;
LABEL DIV0,noErr;
BEGIN
    ASM                 (*  ST  |  1   |  2   |  3   |  4   |  5   |  6   |  7   *)
        FLD a11         (* a11  |      |      |      |      |      |      |      *)
        FLD a22         (* a22  | a11  |      |      |      |      |      |      *)
        FST ST(2)       (* a22  | a11  | a22  |      |      |      |      |      *)
        FMUL ST,ST(1)   (*a22*11| a11  | a22  |      |      |      |      |      *)
        FLD a21         (* a21  |a22*11| a11  | a22  |      |      |      |      *)
        FLD a12         (* a12  | a21  |a22*11| a11  | a22  |      |      |      *)
        FST ST(5)       (* a12  | a21  |a22*11| a11  | a22  | a12  |      |      *)
        FMUL ST,ST(1)   (*a21*12| a21  |a22*11| a11  | a22  | a12  |      |      *)
        FSUB ST,ST(2)   (*  d   | a21  |a22*11| a11  | a22  | a12  |      |      *)
        FTST
        FSTSW status   
        FWAIT          
        MOV AX,status
        SAHF
        JE Div0
        FLD c1          (*  c1  |  d   |  a21 |a22*11| a11  | a22  | a12  |      *)
        FST ST(3)       (*  c1  |  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FMUL ST,ST(2)   (*c1*a21|  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FLD c2          (*  c2  |c1*a21|  d   |  a21 |  c1  | a11  | a22  | a12  *)
        FMUL ST,ST(5)   (*c2*a11|c1*a21|  d   |  a21 |  c1  | a11  | a22  | a12  *)
        FSUBP ST(1),ST  (* N1   |  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FDIV  ST,ST(1)  (* x1   |  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        LES DI,x2
        FSTP DWORD PTR ES:[DI]
                        (*  d   |  a21 |  c1  | a11  | a22  | a12  |      |      *)
        FLD c2          (*  c2  |  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FMUL ST,ST(6)   (*c2*a12|  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FLD ST(3)       (*  c1  |c2*a12|  d   |  a21 |  c1  | a11  | a22  | a12  *)
        FMUL ST,ST(6)   (*c1*a22|c2*a12|  d   |  a21 |  c1  | a11  | a22  | a12  *)
        FSUBP ST(1),ST  (* N2   |  d   |  a21 |  c1  | a11  | a22  | a12  |      *)
        FDIVRP ST(1),ST (* x2   |  a21 |  c1  | a11  | a22  | a12  |      |      *)
        LES DI,x1
        FSTP DWORD PTR ES:[DI]
                        (*  a21 |  c1  | a11  | a22  | a12  |      |      |      *)

        FFREE ST(4)
        FFREE ST(3)
        FFREE ST(2)
        FFREE ST(1)
        FFREE ST

        XOR AX,AX
        JMP noErr
   DIV0:FFREE ST(5)
        FFREE ST(4)
        FFREE ST(3)
        FFREE ST(2)
        FFREE ST(1)
        FFREE ST
        MOV AX,1
  noErr:LES DI,err
        MOV BYTE PTR ES:[DI],AL
        WAIT
    END
END;

(*$ENDIF*)


FUNCTION OwnRandom:RealType;
BEGIN
    CASE seed3 OF
        0:RandSum:=RandSum+RandNumb1[seed1]+RandNumb2[seed2];
        1:RandSum:=RandSum+RandNumb1[seed1]-RandNumb2[seed2];
        2:RandSum:=RandSum-RandNumb1[seed1]+RandNumb2[seed2];
        3:RandSum:=RandSum-RandNumb1[seed1]-RandNumb2[seed2];
        4:RandSum:=RandSum-RandNumb1[seed1]-2*RandNumb2[seed2];
        5:RandSum:=RandSum+2*RandNumb1[seed1]-RandNumb2[seed2];
        6:RandSum:=RandSum+3*RandNumb1[seed1]-2*RandNumb2[seed2];
        7:RandSum:=RandSum+2*RandNumb1[seed1]+2*RandNumb2[seed2];
        8:RandSum:=RandSum-2*RandNumb1[seed1]-3*RandNumb2[seed2];
        9:RandSum:=RandSum+2*RandNumb1[seed1]-2*RandNumb2[seed2];
       10:RandSum:=RandSum+3*RandNumb1[seed1]+3*RandNumb2[seed2]
    END;
    INC(seed1);
    IF seed1=seedCnt1 THEN
        seed1:=0;
    INC(seed2);
    IF seed2=seedCnt2 THEN
        seed2:=0;
    INC(seed3);
    IF seed3=seedCnt3 THEN
        seed3:=0;
    WHILE RandSum>1 DO
        RandSum:=RandSum-1;
    WHILE RandSum<0 DO
        RandSum:=RandSum+1;
    OwnRandom:=RandSum
END;


PROCEDURE DefineBSpline2D(VAR BS:BSpline2D;nn:INTEGER);
BEGIN
    BS.n:=nn
END;


PROCEDURE DefineBSpline2DPoint(VAR BS:BSpline2D;i:INTEGER;xx,yy:RealType);
BEGIN
    BS.P[i].x:=xx;
    BS.P[i].y:=yy
END;


PROCEDURE GetBSpline2D(VAR BS:BSpline2D;u:RealType;VAR rx,ry:RealType);
VAR i1,i2,i3,i4:INTEGER;
    mul:RealType;
BEGIN
    WITH BS DO
    BEGIN
        mul:=u*n;
        i2:=TRUNC(mul);
        u:=(mul-i2);

        i1:=PRED(i2);
        i3:=SUCC(i2);
        i4:=SUCC(i3);

        IF i1<0 THEN
            i1:=0;
        IF i2<0 THEN
            i2:=0;
        IF i3<0 THEN
            i3:=0;
        IF i4<0 THEN
            i4:=0;
        IF i1>n THEN
            i1:=n;
        IF i2>n THEN
            i2:=n;
        IF i3>n THEN
            i3:=n;
        IF i4>n THEN
            i4:=n;

        rx:=((((-P[i1].x+3*P[i2].x-3*P[i3].x+P[i4].x)*u+
              (3*P[i1].x-6*P[i2].x+3*P[i3].x) )*u+
                 (-3*P[i1].x+3*P[i3].x))*u+
                    (P[i1].x+4*P[i2].x+P[i3].x))/6;
        ry:=((((-P[i1].y+3*P[i2].y-3*P[i3].y+P[i4].y)*u+
              (3*P[i1].y-6*P[i2].y+3*P[i3].y) )*u+
                 (-3*P[i1].y+3*P[i3].y))*u+
                    (P[i1].y+4*P[i2].y+P[i3].y))/6
    END
END;


PROCEDURE DefineBSpline3D(VAR BS:BSpline3D;nn,mm:INTEGER);
BEGIN
    BS.n:=nn;
    BS.m:=mm;
    BS.succn:=SUCC(nn)
END;


PROCEDURE DefineBSpline3DPoint(VAR BS:BSpline3D;i,j:INTEGER;xx,yy,zz:RealType);
BEGIN
    WITH BS,P[i+j*succn] DO
    BEGIN
        x:=xx;
        y:=yy;
        z:=zz
    END
END;


PROCEDURE GetBSpline3D(VAR BS:BSpline3D;u,v:RealType;VAR rx,ry,rz:RealType);
VAR ii,jj:ARRAY[1..4] OF INTEGER;
    muli,mulj:Double;
    NN,MM:ARRAY[1..4] OF RealType;
    i,j:INTEGER;

(*$IFOPT N-*)

    cubU,sqrU,cubV,sqrV:REAL;
    rxd,ryd,rzd:REAL;
    dxd,dyd,dzd:REAL;
    ud:REAL;
    vd:REAL;

(*$ELSE*)

    cubU,sqrU,cubV,sqrV:Double;
    rxd,ryd,rzd:Double;
    dxd,dyd,dzd:Double;
    ud:Double;
    vd:Double;

(*$ENDIF*)

BEGIN
    WITH BS DO
    BEGIN
        ud:=u;
        vd:=v;

        muli:=u*n;
        ii[2]:=TRUNC(muli);

        u:=(muli-ii[2]);

        ii[1]:=PRED(ii[2]);
        ii[3]:=SUCC(ii[2]);
        ii[4]:=SUCC(ii[3]);

        IF ii[1]<0 THEN
            ii[1]:=0;
        IF ii[2]<0 THEN
            ii[2]:=0;
        IF ii[3]<0 THEN
            ii[3]:=0;
        IF ii[4]<0 THEN
            ii[4]:=0;
        IF ii[1]>n THEN
            ii[1]:=n;
        IF ii[2]>n THEN
            ii[2]:=n;
        IF ii[3]>n THEN
            ii[3]:=n;
        IF ii[4]>n THEN
            ii[4]:=n;

        sqrU:=Sqr(u);
        cubU:=sqrU*u;
        NN[1]:=(  -cubU+3*sqrU-3*u+1)/6;
        NN[2]:=( 3*cubU-6*sqrU    +4)/6;
        NN[3]:=(-3*cubU+3*sqrU+3*u+1)/6;
        NN[4]:=(   cubU             )/6;



        mulj:=v*m;
        jj[2]:=TRUNC(mulj);

        v:=(mulj-jj[2]);

        jj[1]:=PRED(jj[2]);
        jj[3]:=SUCC(jj[2]);
        jj[4]:=SUCC(jj[3]);

        IF jj[1]<0 THEN
            jj[1]:=0;
        IF jj[2]<0 THEN
            jj[2]:=0;
        IF jj[3]<0 THEN
            jj[3]:=0;
        IF jj[4]<0 THEN
            jj[4]:=0;
        IF jj[1]>m THEN
            jj[1]:=m;
        IF jj[2]>m THEN
            jj[2]:=m;
        IF jj[3]>m THEN
            jj[3]:=m;
        IF jj[4]>m THEN
            jj[4]:=m;

        sqrV:=Sqr(v);
        cubV:=sqrV*v;
        MM[1]:=(  -cubV+3*sqrV-3*v+1)/6;
        MM[2]:=( 3*cubV-6*sqrV    +4)/6;
        MM[3]:=(-3*cubV+3*sqrV+3*v+1)/6;
        MM[4]:=(   cubV             )/6;

        rxd:=0;
        ryd:=0;
        rzd:=0;

        FOR i:=1 TO 4 DO
            FOR j:=1 TO 4 DO
            BEGIN
                dxd:=P[ii[i]+jj[j]*succn].x*NN[i]*MM[j];
                dyd:=P[ii[i]+jj[j]*succn].y*NN[i]*MM[j];
                dzd:=P[ii[i]+jj[j]*succn].z*NN[i]*MM[j];
                rxd:=rxd+dxd;
                ryd:=ryd+dyd;
                rzd:=rzd+dzd
            END;
        rx:=rxd;
        ry:=ryd;
        rz:=rzd;
    END
END;


PROCEDURE GetBSpline3DNorm(VAR BS:BSpline3D;u,v:RealType;VAR rx,ry,rz,nx,ny,nz:RealType);

CONST delta=0.2;

VAR dx,dy,dz:RealType;
    dx1,dy1,dz1:RealType;
    dx2,dy2,dz2:RealType;
BEGIN
    GetBSpline3D(BS,u,v,rx,ry,rz);
    GetBSpline3D(BS,u+delta,v,dx1,dy1,dz1);
    GetBSpline3D(BS,u,v+delta,dx2,dy2,dz2);

    dx1:=dx1-rx;
    dy1:=dy1-ry;
    dz1:=dz1-rz;
    Normalize(dx1,dy1,dz1);

    dx2:=dx2-rx;
    dy2:=dy2-ry;
    dz2:=dz2-rz;

    Normalize(dx2,dy2,dz2);

    Kreuz(dx1,dy1,dz1,dx2,dy2,dz2,nx,ny,nz);
    Normalize(nx,ny,nz)
END;


FUNCTION Between(nr,lowBorder,highBorder:RealType):BOOLEAN;
BEGIN
    Between:=(nr>=lowBorder) AND (nr<=highBorder)
END;



FUNCTION Lin(a1,a2,r:RealType):RealType;
BEGIN
    Lin:=a1*(1-r)+a2*r
END;


FUNCTION BiLin(a11,a12,a21,a22,r1,r2:RealType):RealType;
VAR b1,b2:RealType;
BEGIN
    b1:=Lin(a11,a12,r1);
    b2:=Lin(a21,a22,r1);
    BiLin:=Lin(b1,b2,r2)
END;


FUNCTION TriLin(a111,a112,a121,a122,a211,a212,a221,a222,r1,r2,r3:RealType):RealType;
VAR b11,b12,b21,b22:RealType;
BEGIN
    b11:=Lin(a111,a112,r1);
    b12:=Lin(a121,a122,r1);
    b21:=Lin(a211,a212,r1);
    b22:=Lin(a221,a222,r1);
    TriLin:=BiLin(b11,b12,b21,b22,r2,r3)
END;



BEGIN
    seed1:=0;
    seed2:=0;
    seed3:=0;
    RandSum:=0;
END.
