{$A+,B-,D-,E-,F+,G+,I-,L-,N-,O-,R-,S-,V-}

{$M 16384,0,655360}

UNIT stuff;

(**********************************************************************)
(**********************************************************************)
(***                                                                ***)
(*** Diese Unit stellt verschiedenartige Funktionen zur Verfgung   ***)
(*** die nicht eindeutig einem bestimmten Einsatzgebiet zuzuord-    ***)
(*** nen sind. Vorwiegend sind dies solche, die Zugriffe auf DOS-   ***)
(*** Funktionen bequemer gestalten.                                 ***)
(***                                                                ***)
(**********************************************************************)
(**********************************************************************)


INTERFACE

USES DOS,Crt;

CONST Escape=-1;  (*** EscapeCode fr Choose  ***)
      maxTimer=20;(*** Timer (0..maxTimer)    ***)
      maxStopWatches=20; (*** Stoppuhren      ***)

TYPE STRING30=STRING[30];
     Str255=STRING[255];
     hexType=STRING[4];      (* String fr hexadezimale Zahlendarstellung *)


FUNCTION LastChar(s:STRING):CHAR;
(*** Gibt das letzte Zeichen eines Strings zurck. ***)


FUNCTION LastPos(substr:STR255;s:STR255): BYTE;
(*** Wie Pos, nur da von Hinten gesucht wird. ***)


PROCEDURE KillLast(VAR s:STRING);
(*** Lscht das letzte Zeichen eines Strings.      ***)


PROCEDURE StartStopWatch(nr:BYTE);
(*** Startet eine Stopuhr mit 1/100 s Genauigkeit, ***)
(*** die maximal bis 23:59:59.99 laufen kann.      ***)


FUNCTION GetStopWatch(nr:BYTE):LONGINT;
(*** Gibt die gestoppte Zeit in 1/100 s zurck.    ***)


PROCEDURE StartTimer(nr:BYTE;cs:LONGINT);
(*** Stellt Timer nr in 1/100 s                    ***)


FUNCTION Timer(nr:BYTE):BOOLEAN;
(*** Ist wahr, wenn Timerzeit von Timer nr er-     ***)
(*** reicht.                                       ***)


PROCEDURE GetHMinSec(Time:LONGINT;VAR h,min,sec,sec100:WORD);
(*** Wandelt die Zeit in 1/100 s in Stunden, Mi-   ***)
(*** nuten, Sekunden und 1/100 Sekunden um.        ***)


PROCEDURE GetHMinSecStr(Time:LONGINT;hund:BOOLEAN;VAR s:STRING);
(*** Wandelt die Zeit in eine entsprechendende Zei-***)
(*** chenkette der Form hh:mm:ss.xx oder hh:mm:ss  ***)
(*** um. hund gibt dabei an, ob die 1/100 s dabei  ***)
(*** sein sollen oder nicht.                       ***)


PROCEDURE GetActTimeStr(VAR s:STRING);
(*** Gibt die aktuelle Zeit als String zurck.     ***)


PROCEDURE GetActDateStr(VAR s:STRING);
(*** Gibt das aktuelle Datum als String zurck.    ***)


PROCEDURE StringStr(VAR s:Str255);
(*** Eliminiert alle Character<#32 aus dem String. ***)


PROCEDURE NumbStr(Nr:LONGINT;Format:BYTE;VAR S:STRING);
(*** Wandelt Nr in den String um und fllt vorne   ***)
(*** solange mit '0' auf, bis Format Stellen er-   ***)
(*** reicht sind.                                  ***)


PROCEDURE DecToHex(dec:WORD;VAR hex:hexType);
(*** Wandelt eine positive ganze Zahl ins hexadezi-***)
(*** male System um.                               ***)


PROCEDURE HexToDec(hex:STRING;VAR dec:WORD;VAR code:INTEGER);
(*** Wandelt eine hex-Zahl in die entsprechende    ***)
(*** ganze Zahl um code=0, wenn die Umwandlung ohne***)
(*** Fehler ging, sonst das Zeichen in hex, das den***)
(*** Fehler verursachte.                           ***)


FUNCTION DayOfWeek(day,mon,year:WORD):BYTE;
(*** Rechnet den Wochentag eines Datums aus. Dabei ***)
(*** mu das Jahr mit Jahrhundert angegeben wer-   ***)
(*** den. Das Ergebnis lautet 0 fr Samstag bis    ***)
(*** 6 fr Freitag.                                ***)


PROCEDURE DayStr(daynr:BYTE;VAR s:STRING);
(*** Wandelt die Tagesnummer in den entsprechenden ***)
(*** String um (deutsch)                           ***)


PROCEDURE ROL(VAR b);
(*** Rotiert b vom Typ Byte oder CHR nach links    ***)


PROCEDURE ROR(VAR b);
(*** Rotiert b vom Typ Byte oder CHR nach rechts   ***)


PROCEDURE TextInvers;
(*** Folgende Textausgaben erscheinen invers       ***)


PROCEDURE TextNormal;
(*** Folgende Textausgaben erscheinen normal.      ***)


PROCEDURE WriteEdit(VAR txt;x1,y1,x2,y2:BYTE);
(*** Schreibt den Editortext auf den angegebenen   ***)
(*** Bildschirmbereich.                            ***)


PROCEDURE edit(VAR txt;x1,y1,x2,y2:BYTE);
(*** Editiert einen Text vom Typ ARRAY [0..y2-y1+1]***)
(*** OF STRING. Die Bildschirmposition der linken  ***)
(*** oberen Ecke wird mit x1,y2 gegeben,die der    ***)
(*** rechten durch x2,y2. Das Ende des Textes wird ***)
(*** durch ein einzelnes #255 markiert. Ist y1=y2  ***)
(*** wird nur eine Zeile eingelesen und mit Return ***)
(*** beendet                                       ***)
(*** Folgende Steuertasten sind belegt:            ***)
(***    Pfeile: bewegen den Cursor zeichenweise    ***)
(***    Bild auf,ab:Erste bzw. letzte Zeile        ***)
(***    Pos1,Ende:Erstes bzw letztes Zeichen       ***)
(***    Delete:Lschen und nach links gehen        ***)
(***    Entr:Lschen und stehen bleiben            ***)
(***    Einfg:Umschalte zwischen berschreiben und ***)
(***          Einfgen                             ***)


PROCEDURE ClearEdit(VAR txt);
(*** Lscht die Angegebene Variable, so da mit    ***)
(*** edit begonnen werden kann.                    ***)


PROCEDURE Frame(x1,y1,x2,y2:BYTE;double:BOOLEAN);
(*** Macht eine Rahmen um die angegebenen Koordina-***)
(*** ten. double gibt an, ob der Rahmen mit doppel-***)
(*** ten Strichen gemacht werden soll.             ***)


PROCEDURE Choose(VAR ar;fill:INTEGER;x,y,xl,yl,len:BYTE;clr:BOOLEAN;VAR ch:INTEGER);
(*** Steuert eine 2-dimensionale Auswahl eines Fel-***)
(*** des. xl ist dabei die Anzahl der Strings pro  ***)
(*** Zeile und yl die Zeilenzahl. fill gibt das    ***)
(*** letzte belegte Feld an. ar mu vom Typ        ***)
(*** ARRAY[0..max] OF STRING30 sein. Das linke obe-***)
(*** re Feld steht bei x,y. len gibt die maximale  ***)
(*** Stringlnge an. Das Ergebnis steht in ch oder ***)
(*** ch=255 fr Escape. Ist clr gesetzt, dann      ***)
(*** wird nach der Auswahl das Feld gelscht.      ***)


FUNCTION NormChar(c:CHAR):CHAR;
(*** Wandelt alle Auslndischen Zeichen in ent-    ***)
(*** sprechende USA Zeichen um (z.B) #142 in A usw.***)


PROCEDURE NormString(VAR s:STRING);
(*** Wandelt alle Zeichen eines Strings gem      ***)
(*** NormChar um.                                  ***)


FUNCTION GermanChar(c:CHAR):CHAR;
(*** Wie NormChar, nur da deutsche Umlaute erhal- ***)
(*** ten bleiben.                                  ***)


PROCEDURE GermanString(VAR s:STRING);
(*** Wie NormString, nur mit GermanChar.           ***)


FUNCTION UpChar(c:CHAR):CHAR;
(*** Wandelt ein kleinen Buchstaben in den entspr. ***)
(*** Groen um (auch ,,).                       ***)



PROCEDURE UpString(VAR s:STRING);
(*** Wandelt alle kleinen Zeichen eines Strings in ***)
(*** die entsprechenden Groen um.                 ***)


PROCEDURE GetNameOfFile(s:STRING;VAR name:STRING);
(*** Gibt von einem Pfad nur den Filenamen zurck  ***)
(*** oder '\', falls es sich um das Rootdirectory  ***)
(*** handelt.                                      ***)


PROCEDURE GetPathOfFile(s:STRING;VAR path:STRING);
(*** Gibt von einem kompletten Pfad nur den Pfad   ***)
(*** ohne Dateiname zurck.                        ***)


PROCEDURE SplitPath(s:STRING;VAR vol:CHAR;VAR path,name:STRING);
(*** Teilt einen kompletten Pfad in Laufwerk, Di-  ***)
(*** rectory und Filename ein z.B. "A:\sys\x.tst"  ***)
(*** gibt "A", "\sys" und "x.tst" zurck. Das Gert***)
(*** mu im String enthalten sein.                 ***)


FUNCTION ParamOptions:BYTE;
(*** Ermittelt die Anzahl der Optionen, die als Pa-***)
(*** rameter beim Aufruf mitgegeben wurden         ***)


FUNCTION ParamNames:BYTE;
(*** Ermittelt die Anzahl der Sonstigen Namen, die ***)
(*** beim Aufruf mitgegeben wurden                 ***)


PROCEDURE GetOption(VAR s:STRING);
(*** Liefert die nchste Option (ohne /). Vorher   ***)
(*** mute ParamOptions erfolgt sein. Alle Klein-  ***)
(*** buchstaben werden in groe umgewandelt.       ***)


PROCEDURE GetOption2(VAR s:STRING);
(*** Wie oben, nur da nur der 1. Buchstabe nach   ***)
(*** gro umgewandelt wird.                        ***)


PROCEDURE GetName(VAR s:STRING);
(*** Liefert den nchsten Namen. Vorher mute      ***)
(*** ParamNames erfolgt sein                       ***)


PROCEDURE GetCopyright(VAR s:STRING);
(*** Gibt den String '(C) by Jrg Roth' zurck     ***)

PROCEDURE WriteCopyright;
(*** Gibt die Meldung '(C) by Jrg Roth' aus       ***)


FUNCTION GetCheckSum(p:POINTER;len:LONGINT):LONGINT;
(*** Berechnet eine Checksumme                     ***)


PROCEDURE GetResultString(VAR s:STRING;IOR:INTEGER);
(*** Gibt File-Fehler als STRING zurck.           ***)


FUNCTION InitCopy(Size:WORD):BOOLEAN;
(*** Erzeugt einen Copybuffer der angegebenen      ***)
(*** Gre. Wenn nicht genug Speicher vorhanden    ***)
(*** wird FALSE zurckgegeben.                     ***)


PROCEDURE FreeCopy;
(*** Gibt den Copybuffer wieder frei.              ***)


FUNCTION CopyFile(Name1,Name2:STRING):INTEGER;
(*** Kopiert File mit Namen Name1 auf das File     ***)
(*** Name2. Dabei knnen die Namen Gert und Pfad  ***)
(*** enthalten. Der Rckgabewert entspricht dem    ***)
(*** Fehlercode gem IOResult.                    ***)


PROCEDURE DeleteFile(Name:STRING);
(*** Lscht das angebene File.                     ***)


FUNCTION CountTextLines(Name:STRING;VAR Lines,Cols:WORD):INTEGER;
(*** Zhlt bei einem Text die Zeilen und die max.  ***)
(*** Zeichenzahl in einer Zeile. Tritt beim ffnen ***)
(*** ein Fehler auf, wird dieser als Funktionswert ***)
(*** zurckgegeben.                                ***)


FUNCTION GetDrive(ID:CHAR):BYTE;
(*** Eingegeben wird der Laufwerksbuchstabe (klein ***)
(*** oder gro. Ausgegeben wird:                   ***)
(***       0:Laufwerk nicht angeschlossen          ***)
(***       1:Fixmedium                             ***)
(***       2:Wechselmedium                         ***)


FUNCTION WipeDir(path,wildcard:STRING):INTEGER;
(*** Lscht alle Files des Directories path (ohne  ***)
(***  "\" ), die dem wildcard entsprechen          ***)


IMPLEMENTATION

VAR StopTime:ARRAY[0..maxStopWatches] OF LONGINT;
    TimerStart:ARRAY[0..maxTimer] OF LONGINT;
    TimerCs:ARRAY[0..maxTimer] OF LONGINT;
    optcnt,namecnt:BYTE;
    BuffSize:WORD;
    CopyBuffer:POINTER;


FUNCTION LastChar(s:STRING):CHAR;
BEGIN
    LastChar:=s[Length(s)]
END;


FUNCTION LastPos(substr:STR255;s:STR255): BYTE;
VAR i,j:BYTE;
    same:BOOLEAN;
BEGIN
    IF subStr='' THEN
        Exit;

    i:=Length(s)-Length(subStr)+1;
    WHILE i>0 DO
    BEGIN
        IF s[i]=subStr[1] THEN
        BEGIN
            j:=1;
            same:=TRUE;
            WHILE (j<=Length(subStr)) AND same DO
                IF subStr[j]<>s[PRED(i+j)] THEN
                    same:=FALSE
                ELSE
                    INC(j);
            IF same THEN
            BEGIN
                LastPos:=i;
                Exit
            END
        END;
        DEC(i)
    END;
    LastPos:=0
END;


PROCEDURE KillLast(VAR s:STRING);
BEGIN
    s:=Copy(s,1,PRED(Length(s)))
END;


FUNCTION ConvertTime(h,min,sec,sec100:LONGINT):LONGINT;
BEGIN
    ConvertTime:=sec100+sec*100+min*6000+h*360000
END;


PROCEDURE StartStopWatch(nr:BYTE);
VAR h,min,sec,sec100:WORD;
BEGIN
    GetTime(h,min,sec,sec100);
    StopTime[nr]:=ConvertTime(h,min,sec,sec100)
END;


FUNCTION GetStopWatch(nr:BYTE):LONGINT;
VAR h,min,sec,sec100:WORD;
    TimeDiff:LONGINT;
BEGIN
    GetTime(h,min,sec,sec100);
    TimeDiff:=ConvertTime(h,min,sec,sec100)-StopTime[nr];
    IF TimeDiff<0 THEN
        TimeDiff:=TimeDiff+8640000;
    GetStopWatch:=TimeDiff
END;


PROCEDURE StartTimer(nr:BYTE;cs:LONGINT);
VAR h,min,sec,sec100:WORD;
BEGIN
    GetTime(h,min,sec,sec100);
    TimerStart[nr]:=ConvertTime(h,min,sec,sec100);
    TimerCs[nr]:=cs
END;


FUNCTION Timer(nr:BYTE):BOOLEAN;
VAR h,min,sec,sec100:WORD;
    TimeDiff:LONGINT;
BEGIN
    GetTime(h,min,sec,sec100);
    TimeDiff:=ConvertTime(h,min,sec,sec100)-TimerStart[nr];
    IF TimeDiff<0 THEN
        TimeDiff:=TimeDiff+8640000;
    Timer:=(TimeDiff>=TimerCs[nr])
END;



PROCEDURE GetHMinSec(Time:LONGINT;VAR h,min,sec,sec100:WORD);
BEGIN
    sec100:=Time MOD 100;
    sec:=Time DIV 100 MOD 60;
    min:=Time DIV 6000 MOD 60;
    h:=Time DIV 360000 MOD 24
END;


PROCEDURE GetHMinSecStr(Time:LONGINT;hund:BOOLEAN;VAR s:STRING);
VAR h,min,sec,sec100:WORD;
    hstr,minstr,secstr,sec100str:STRING;
BEGIN
    GetHMinSec(Time,h,min,sec,sec100);
    NumbStr(h,2,hstr);
    NumbStr(min,2,minstr);
    NumbStr(sec,2,secstr);
    IF hund THEN
    BEGIN
        NumbStr(sec100,2,sec100str);
        s:=hstr+':'+minstr+':'+secstr+'.'+sec100str
    END
    ELSE
        s:=hstr+':'+minstr+':'+secstr
END;


PROCEDURE GetActTimeStr(VAR s:STRING);
VAR H,Min,Sec,Sec100:WORD;
    s2:STRING[3];
BEGIN
    GetTime(H,Min,Sec,Sec100);
    Str(H:2,s);
    NumbStr(Min,2,s2);
    s:=s+':'+s2+':';
    NumbStr(Sec,2,s2);
    s:=s+s2
END;


PROCEDURE GetActDateStr(VAR s:STRING);
VAR Year,Mon,Day,DOW:WORD;
    s2:STRING[5];
BEGIN
    GetDate(Year,Mon,Day,DOW);
    Str(Day:2,s);
    Str(Mon:2,s2);
    s:=s+'.'+s2+'.';
    Str(Year:4,s2);
    s:=s+s2
END;


PROCEDURE StringStr(VAR s:Str255);
VAR help:Str255;
    i:BYTE;
BEGIN
    help:=s;
    s:='';
    FOR i:=1 TO Length(help) DO
        IF ORD(help[i])>=32 THEN
            s:=s+help[i]
END;


PROCEDURE NumbStr(Nr:LONGINT;Format:BYTE;VAR S:STRING);
VAR i:BYTE;
BEGIN
    Str(Nr,S);
    FOR i:=SUCC(Length(S)) TO Format DO
        S:='0'+S
END;


PROCEDURE DecToHex(dec:WORD;VAR hex:hexType);

    FUNCTION DecToHexNibble(nib:BYTE):hexType;
    BEGIN
        IF nib<10 THEN
            DecToHexNibble:=CHR(nib+48)
        ELSE
            DecToHexNibble:=CHR(nib+55)
    END;

    FUNCTION DecToHexByte(byt:BYTE):hexType;
    BEGIN
        DecToHexByte:=DecToHexNibble(byt DIV 16)+DecToHexNibble(byt MOD 16)
    END;

BEGIN
    hex:=DecToHexByte(Hi(dec))+DecToHexByte(Lo(dec))
END;


PROCEDURE HexToDec(hex:STRING;VAR dec:WORD;VAR code:INTEGER);
VAR c:CHAR;
    i:BYTE;
BEGIN
    dec:=0;
    FOR i:=1 TO Length(hex) DO
    BEGIN
        c:=UpCase(hex[i]);
        IF (c>='0') AND (c<='9') THEN
            dec:=dec*16+ORD(c)-48
        ELSE IF (c>='A') AND (c<='F') THEN
            dec:=dec*16+ORD(c)-55
        ELSE BEGIN
            code:=i;
            Exit
        END
    END;
    code:=0
END;


FUNCTION DayOfWeek(day,mon,year:WORD):BYTE;
BEGIN
    IF mon>2 THEN
        INC(mon)
    ELSE BEGIN
        INC(mon,13);
        DEC(year)
    END;
    DayOfWeek:=(TRUNC(year*365.25)+TRUNC(mon*30.6)+day-1) MOD 7
END;


PROCEDURE DayStr(daynr:BYTE;VAR s:STRING);
BEGIN
    CASE daynr OF
       0:s:='Samstag';
       1:s:='Sonntag';
       2:s:='Montag';
       3:s:='Dienstag';
       4:s:='Mittwoch';
       5:s:='Donnerstag';
       6:s:='Freitag'
    ELSE s:='???'
    END
END;


PROCEDURE ROL(VAR b);
BEGIN
    IF BYTE(b)>=128 THEN
        BYTE(b):=SUCC(BYTE(b) MOD 128 SHL 1)
    ELSE
        BYTE(b):=BYTE(b) SHL 1
END;


PROCEDURE ROR(VAR b);
BEGIN
    IF ODD(BYTE(b)) THEN
        BYTE(b):=BYTE(b) SHR 1+128
    ELSE
        BYTE(b):=BYTE(b) SHR 1
END;


PROCEDURE TextInvers;
BEGIN
    TextColor(black);
    TextBackGround(white)
END;


PROCEDURE TextNormal;
BEGIN
    TextColor(white);
    TextBackGround(black)
END;


PROCEDURE WriteEdit(VAR txt;x1,y1,x2,y2:BYTE);

TYPE txtType=ARRAY[0..24] OF STRING;

VAR size:BYTE;

BEGIN
    Window(x1,y1,x2,y2);
    ClrScr;
    size:=0;
    WHILE txtType(txt)[size]<>#255 DO
    BEGIN
        GotoXY(1,SUCC(size));
        Write(txtType(txt)[size]);
        INC(size)
    END;
    Window(1,1,80,25)
END;


PROCEDURE edit(VAR txt;x1,y1,x2,y2:BYTE);

TYPE txtType=ARRAY[0..24] OF STRING;

VAR i:BYTE;
    curx,cury:BYTE;
    c:CHAR;
    size:BYTE;
    ins:BOOLEAN;

BEGIN
    Window(x1,y1,x2,y2);
    ClrScr;
    ins:=TRUE;
    size:=0;
    WHILE txtType(txt)[size]<>#255 DO
    BEGIN
        GotoXY(1,SUCC(size));
        Write(txtType(txt)[size]);
        INC(size)
    END;
    curx:=0;
    cury:=0;
    REPEAT
         GotoXY(SUCC(curx),SUCC(cury));
         c:=ReadKey;
         CASE c OF
             #27:IF y2<>y1 THEN
                 BEGIN
                     Window(1,1,80,25);
                     Exit
                 END;
             #13:IF y2=y1 THEN
                 BEGIN
                     Window(1,1,80,25);
                     Exit
                 END
                 ELSE IF ins THEN
                 BEGIN
                     IF size<=y2-y1 THEN
                     BEGIN
                         INC(size);
                         FOR i:=size DOWNTO SUCC(cury) DO
                              txtType(txt)[SUCC(i)]:=txtType(txt)[i];
                         txtType(txt)[SUCC(cury)]:=Copy(txtType(txt)[cury],SUCC(curx),255);
                         txtType(txt)[cury]:=Copy(txtType(txt)[cury],1,curx);
                         ClrEol;
                         curx:=0;
                         INC(cury);
                         GotoXY(SUCC(curx),SUCC(cury));
                         InsLine;
                         Write(txtType(txt)[cury])
                     END
                 END
                 ELSE
                     IF cury<size THEN
                     BEGIN
                         INC(cury);
                         curx:=0
                     END;
             #8: IF curx OR cury<>0 THEN
                     IF curx>0 THEN
                     BEGIN
                         Delete(txtType(txt)[cury],curx,1);
                         GotoXY(1,SUCC(cury));
                         Write(txtType(txt)[cury],' ');
                         DEC(curx)
                     END
                     ELSE BEGIN
                         DEC(cury);
                         curx:=Length(txtType(txt)[cury]);
                         txtType(txt)[cury]:=Copy(txtType(txt)[cury]+txtType(txt)[SUCC(cury)],1,x2-x1);
                         FOR i:=SUCC(cury) TO PRED(size) DO
                             txtType(txt)[i]:=txtType(txt)[SUCC(i)];
                         DEC(size);
                         DelLine;
                         GotoXY(1,SUCC(cury));
                         Write(txtType(txt)[cury])
                     END;
             #0: BEGIN
                     c:=ReadKey;
                     CASE c OF
                         #72:IF cury>0 THEN
                             BEGIN
                                 DEC(cury);
                                 IF curx>Length(txtType(txt)[cury]) THEN
                                     curx:=Length(txtType(txt)[cury])
                             END;
                         #80:IF cury<PRED(size) THEN
                             BEGIN
                                 INC(cury);
                                 IF curx>Length(txtType(txt)[cury]) THEN
                                     curx:=Length(txtType(txt)[cury])
                             END;
                         #75:IF curx>0 THEN
                                 DEC(curx);
                         #77:IF curx<Length(txtType(txt)[cury]) THEN
                                 INC(curx);
                         #71:curx:=0;
                         #79:curx:=Length(txtType(txt)[cury]);
                         #73:cury:=0;
                         #81:cury:=PRED(size);
                         #83:BEGIN
                                 Delete(txtType(txt)[cury],SUCC(curx),1);
                                 GotoXY(1,SUCC(cury));
                                 Write(txtType(txt)[cury],' ')
                             END;
                         #82:ins:=NOT ins
                     END
                 END;
            ELSE IF ins THEN
                 BEGIN
                     IF Length(txtType(txt)[cury])<x2-x1 THEN
                     BEGIN
                         Insert(c,txtType(txt)[cury],SUCC(curx));
                         GotoXY(1,SUCC(cury));
                         INC(curx);
                         Write(txtType(txt)[cury])
                     END
                 END
                 ELSE IF curx<Length(txtType(txt)[cury]) THEN
                      BEGIN
                          txtType(txt)[cury][SUCC(curx)]:=c;
                          GotoXY(SUCC(curx),SUCC(cury));
                          Write(c);
                          INC(curx)
                      END
         END
    UNTIL FALSE
END;


PROCEDURE ClearEdit(VAR txt);
TYPE txtType=ARRAY[0..24] OF STRING;
BEGIN
    txtType(txt)[0]:='';
    txtType(txt)[1]:=#255
END;


PROCEDURE Frame(x1,y1,x2,y2:BYTE;double:BOOLEAN);
VAR i:BYTE;
BEGIN
    GotoXY(x1,PRED(y1));
    FOR i:=x1 TO x2 DO
        IF double THEN
            Write('')
        ELSE
            Write('');
    GotoXY(x1,SUCC(y2));
    FOR i:=x1 TO x2 DO
        IF double THEN
            Write('')
        ELSE
            Write('');
    FOR i:=y1 TO y2 DO
    BEGIN
        GotoXY(PRED(x1),i);
        IF double THEN
            Write('')
        ELSE
            Write('');
        GotoXY(SUCC(x2),i);
        IF double THEN
            Write('')
        ELSE
            Write('')
    END;
    IF double THEN
    BEGIN
        GotoXY(PRED(x1),PRED(y1));
        Write('');
        GotoXY(PRED(x1),SUCC(y2));
        Write('');
        GotoXY(SUCC(x2),PRED(y1));
        Write('');
        GotoXY(SUCC(x2),SUCC(y2));
        Write('')
    END
    ELSE BEGIN
        GotoXY(PRED(x1),PRED(y1));
        Write('');
        GotoXY(PRED(x1),SUCC(y2));
        Write('');
        GotoXY(SUCC(x2),PRED(y1));
        Write('');
        GotoXY(SUCC(x2),SUCC(y2));
        Write('')
    END
END;


PROCEDURE Choose(VAR ar;fill:INTEGER;x,y,xl,yl,len:BYTE;clr:BOOLEAN;VAR ch:INTEGER);

TYPE arType=ARRAY[0..1023] OF STRING30;

VAR yoffs,yy,i,j,curx,cury:BYTE;
    c:CHAR;

BEGIN
    IF fill<0 THEN
    BEGIN
        ch:=Escape;
        Exit
    END;
    yoffs:=0;
    yy:=SUCC(fill DIV xl);
    IF yy<yl THEN
        yy:=yl;
    Window(x,y,x+PRED(xl*len),PRED(y+yl));
    ClrScr;
    FOR i:=0 TO PRED(xl) DO
        FOR j:=0 TO PRED(yl) DO
            IF i*yy+j<=fill THEN
            BEGIN
                GotoXY(SUCC(i*len),SUCC(j));
                Write(arType(ar)[i*yy+j])
            END;
    curx:=0;
    cury:=0;
    REPEAT
        TextInvers;
        GotoXY(SUCC(curx*len),SUCC(cury));
        Write(arType(ar)[yoffs+curx*yy+cury]);
        c:=ReadKey;
        TextNormal;
        GotoXY(SUCC(curx*len),SUCC(cury));
        Write(arType(ar)[yoffs+curx*yy+cury]);
        CASE c OF
            #27:BEGIN
                    ch:=Escape;
                    IF clr THEN
                        ClrScr;
                    Window(1,1,80,25);
                    Exit
                END;
            #13:BEGIN
                    IF clr THEN
                        ClrScr;
                    ch:=yoffs+curx*yy+cury;
                    Window(1,1,80,25);
                    Exit
                END;
            #0: BEGIN
                    c:=ReadKey;
                    CASE c OF
                        #80:IF (cury<PRED(yl)) AND (yoffs+curx*yy+SUCC(cury)<=fill) THEN
                                INC(cury)
                            ELSE IF (yoffs+yl<yy) AND (yoffs+curx*yy+SUCC(cury)<fill) THEN
                                 BEGIN
                                     INC(yoffs);
                                     GotoXY(1,1);
                                     DelLine;
                                     FOR i:=0 TO PRED(xl) DO
                                         IF yoffs+i*yy+PRED(yl)<=fill THEN
                                         BEGIN
                                             GotoXY(SUCC(i*len),yl);
                                             Write(arType(ar)[yoffs+i*yy+PRED(yl)])
                                         END
                                 END;
                        #72:IF cury>0 THEN
                                DEC(cury)
                            ELSE IF yoffs>0 THEN
                                 BEGIN
                                     DEC(yoffs);
                                     GotoXY(1,1);
                                     InsLine;
                                     FOR i:=0 TO PRED(xl) DO
                                         IF yoffs+i*yy<=fill THEN
                                         BEGIN
                                             GotoXY(SUCC(i*len),1);
                                             Write(arType(ar)[yoffs+i*yy])
                                         END
                                 END;
                        #75:IF curx>0 THEN
                                DEC(curx)
                            ELSE BEGIN
                                curx:=PRED(xl);
                                WHILE (yoffs+curx*yy+cury>fill) DO
                                    DEC(curx)
                            END;
                        #77:IF (curx<PRED(xl)) AND (yoffs+SUCC(curx)*yy+cury<=fill) THEN
                                INC(curx)
                            ELSE
                                curx:=0;
                        #71:curx:=0;
                        #79:BEGIN
                                curx:=PRED(xl);
                                WHILE (curx*yy+cury>fill) DO
                                    DEC(curx)
                            END;
                        #73:cury:=0;
                        #81:BEGIN
                                cury:=PRED(yl);
                                WHILE (curx*yy+cury>fill) DO
                                    DEC(cury)
                            END
                    END
                END
        END
    UNTIL FALSE
END;


FUNCTION NormChar(c:CHAR):CHAR;
BEGIN
    CASE c OF
        '':NormChar:='C';
        '','','','':NormChar:='u';
        '','','','':NormChar:='e';
        '','','','','','':NormChar:='a';
        '':NormChar:='c';
        '','','','':NormChar:='i';
        '','','':NormChar:='A';
        '':NormChar:='E';
        '','','','':NormChar:='o';
        '':NormChar:='y';
        '':NormChar:='U';
        '':NormChar:='n';
        '':NormChar:='N';
        '':NormChar:='s'
       ELSE NormChar:=c
    END
END;


PROCEDURE NormString(VAR s:STRING);
VAR i:BYTE;
BEGIN
    FOR i:=1 TO Length(s) DO
        s[i]:=NormChar(s[i])
END;


FUNCTION GermanChar(c:CHAR):CHAR;
BEGIN
    CASE c OF
        '':GermanChar:='C';
        '','','':GermanChar:='u';
        '','','','':GermanChar:='e';
        '','','','','':GermanChar:='a';
        '':GermanChar:='c';
        '','','','':GermanChar:='i';
        '','':GermanChar:='A';
        '':GermanChar:='E';
        '','','':GermanChar:='o';
        '':GermanChar:='y';
        '':GermanChar:='n';
        '':GermanChar:='N'
       ELSE GermanChar:=c
    END
END;


PROCEDURE GermanString(VAR s:STRING);
VAR i:BYTE;
BEGIN
    FOR i:=1 TO Length(s) DO
        s[i]:=GermanChar(s[i])
END;


FUNCTION UpChar(c:CHAR):CHAR;
BEGIN
    CASE c OF
            '':UpChar:='';
            '':UpChar:='';
            '':UpChar:=''
        ELSE
            UpChar:=UpCase(c)
        END
END;


PROCEDURE UpString(VAR s:STRING);
VAR i:BYTE;
BEGIN
    FOR i:=1 TO Length(s) DO
        s[i]:=UpChar(s[i])
END;


PROCEDURE GetNameOfFile(s:STRING;VAR name:STRING);
VAR i:BYTE;
BEGIN
    IF LastChar(s)='\' THEN
        name:='\'
    ELSE BEGIN
        i:=PRED(Length(s));
        WHILE i>0 DO
        BEGIN
            IF s[i]='\' THEN
            BEGIN
                name:=Copy(s,SUCC(i),255);
                Exit
            END;
            DEC(i)
        END;
        name:=s
    END
END;

PROCEDURE GetPathOfFile(s:STRING;VAR path:STRING);
VAR i:BYTE;
BEGIN
    IF LastChar(s)='\' THEN
        path:=''
    ELSE BEGIN
        i:=PRED(Length(s));
        WHILE i>0 DO
        BEGIN
            IF s[i]='\' THEN
            BEGIN
                path:=Copy(s,1,PRED(i));
                IF (path='') OR (path[Length(path)]=':') THEN
                    path:=path+'\';
                Exit
            END;
            DEC(i)
        END;
        path:=''
    END
END;

PROCEDURE SplitPath(s:STRING;VAR vol:CHAR;VAR path,name:STRING);
VAR i:BYTE;
BEGIN
    vol:=UpCase(s[1]);
    i:=PRED(Length(s));
    WHILE (i>1) AND (s[i]<>'\') DO
        DEC(i);
    IF i=1 THEN
    BEGIN
        path:='.';
        name:=Copy(s,3,255)
    END
    ELSE BEGIN
        path:=Copy(s,3,i-3);
        name:=Copy(s,SUCC(i),255)
    END
END;



FUNCTION ParamOptions:BYTE;
VAR i:BYTE;
    anz:BYTE;
BEGIN
    anz:=0;
    FOR i:=1 TO ParamCount DO
        IF Copy(ParamStr(i),1,1)='/' THEN
            INC(anz);
    optcnt:=1;
    ParamOptions:=anz
END;


FUNCTION ParamNames:BYTE;
VAR i:BYTE;
    anz:BYTE;
BEGIN
    anz:=0;
    FOR i:=1 TO ParamCount DO
        IF Copy(ParamStr(i),1,1)<>'/' THEN
            INC(anz);
    namecnt:=1;
    ParamNames:=anz
END;


PROCEDURE GetOption(VAR s:STRING);
BEGIN
    WHILE Copy(ParamStr(optcnt),1,1)<>'/' DO
        INC(optcnt);
    s:=Copy(ParamStr(optcnt),2,255);
    UpString(s);
    INC(optcnt)
END;


PROCEDURE GetOption2(VAR s:STRING);
BEGIN
    WHILE Copy(ParamStr(optcnt),1,1)<>'/' DO
        INC(optcnt);
    s:=Copy(ParamStr(optcnt),2,255);
    s[1]:=UpCase(s[1]);
    INC(optcnt)
END;


PROCEDURE GetName(VAR s:STRING);
BEGIN
    WHILE Copy(ParamStr(namecnt),1,1)='/' DO
        INC(namecnt);
    s:=ParamStr(namecnt);
    INC(namecnt)
END;


PROCEDURE GetCopyright(VAR s:STRING);
CONST crypt:ARRAY[1..13,1..3] OF BYTE=
            ((1,38,2),(3,20,7),(10,4,1),(16,1,16),(73,1,1),(7,20,8),
             (10,10,14),(31,3,10),(2,11,10),(19,4,6),(189,0,111),
             (4,4,100),(20,5,4));

VAR i:BYTE;
    proof:INTEGER;
BEGIN
    proof:=0;
    s:='(C) Jrg Roth';
    FOR i:=1 TO 13 DO
    BEGIN
        s[i]:=CHR(crypt[i,1]*crypt[i,2]+crypt[i,3]);
        proof:=proof+crypt[i,1]+crypt[i,2]+crypt[i,3]
    END;
    IF proof=796 THEN
        Exit;
    WriteLn('Fatal Error');
    Halt(1)
END;




PROCEDURE WriteCopyright;
VAR s:STRING;
BEGIN
    GetCopyright(s);
    Write(s)
END;




FUNCTION GetCheckSum(p:POINTER;len:LONGINT):LONGINT;

TYPE arr=ARRAY[0..100] OF BYTE;

VAR sum:RECORD
            CASE BOOLEAN OF
                FALSE:(l:LONGINT);
                TRUE:(nr1:WORD;
                      nr2:BYTE;
                      check:BYTE)
        END;
    field:^arr;
    i:LONGINT;
    xorsum:BYTE;
BEGIN
    sum.l:=0;
    xorsum:=0;
    field:=p;
    FOR i:=0 TO PRED(len) DO
    BEGIN
        INC(sum.l,field^[i]);
        ROR(xorsum);
        xorsum:=xorsum XOR field^[i]
    END;
    sum.check:=xorsum;
    GetCheckSum:=sum.l
END;


PROCEDURE GetResultString(VAR s:STRING;IOR:INTEGER);
BEGIN
    CASE IOR OF
          0:s:='No error';
          2:s:='File not found';
          3:s:='Path not found';
          4:s:='Too many open files';
          5:s:='File access denied';
          6:s:='Invalid file handle';
         12:s:='Invalid file access mode';
         15:s:='Invalid drive number';
         16:s:='Cannot remove current directory';
         17:s:='Cannot rename across drives';
        100:s:='Disk read error';
        101:s:='Disk write error';
        102:s:='File not assigned';
        103:s:='File not open';
        104:s:='File not open for input';
        105:s:='File not open for output';
        106:s:='Invalid numeric format';
        150:s:='Disk write protected';
        151:s:='Unknown unit';
        152:s:='Drive not ready';
        153:s:='Unknown command';
        154:s:='CRC error in data';
        155:s:='Bad drive request structure length';
        156:s:='Disk seed error';
        157:s:='Unknown media type';
        158:s:='Sector not found';
        159:s:='Printer out of paper';
        160:s:='Device write fault';
        161:s:='Device read fault';
        162:s:='Hardware failure';
      32767:s:='Not enough memory'
       ELSE s:='Unknown error'
    END
END;


FUNCTION InitCopy(Size:WORD):BOOLEAN;
BEGIN
    BuffSize:=Size;
    IF MaxAvail<BuffSize+10 THEN
    BEGIN
        InitCopy:=FALSE;
        Exit
    END;
    GetMem(CopyBuffer,BuffSize);
    InitCopy:=TRUE
END;


PROCEDURE FreeCopy;
BEGIN
    FreeMem(CopyBuffer,BuffSize)
END;


FUNCTION CopyFile(Name1,Name2:STRING):INTEGER;
VAR f1,f2:FILE;
    IOR:INTEGER;
    len:LONGINT;
BEGIN
    Assign(f1,Name1);
    Reset(f1,1);
    IOR:=IOResult;
    IF IOR>0 THEN
    BEGIN
        CopyFile:=IOR;
        Exit
    END;
    len:=FileSize(f1);
    IF DiskFree(ORD(Name2[1])-64)<len THEN
    BEGIN
        CopyFile:=101;
        Exit
    END;
    Assign(f2,Name2);
    ReWrite(f2,1);
    IOR:=IOResult;
    IF IOR>0 THEN
    BEGIN
        CopyFile:=IOR;
        Exit
    END;
    len:=FileSize(f1);
    IF DiskFree(ORD(Name2[1])-64)<len THEN
    BEGIN
        CopyFile:=101;
        Exit
    END;
    REPEAT
        IF len<BuffSize THEN
        BEGIN
            BlockRead(f1,CopyBuffer^,len);
            IOR:=IOResult;
            IF IOR>0 THEN
            BEGIN
                CopyFile:=IOR;
                Exit
            END;
            BlockWrite(f2,CopyBuffer^,len);
            IOR:=IOResult;
            IF IOR>0 THEN
            BEGIN
                CopyFile:=IOR;
                Exit
            END;
            Close(f1);
            IOR:=IOResult;
            IF IOR>0 THEN
            BEGIN
                CopyFile:=IOR;
                Exit
            END;
            Close(f2);
            CopyFile:=IOResult;
            Exit
        END;
        BlockRead(f1,CopyBuffer^,BuffSize);
        IOR:=IOResult;
        IF IOR>0 THEN
        BEGIN
            CopyFile:=IOR;
            Exit
        END;
        BlockWrite(f2,CopyBuffer^,BuffSize);
        IOR:=IOResult;
        IF IOR>0 THEN
        BEGIN
            CopyFile:=IOR;
            Exit
        END;
        DEC(len,BuffSize)
    UNTIL FALSE
END;

PROCEDURE DeleteFile(Name:STRING);
VAR f:FILE;
BEGIN
    Assign(f,Name);
    Erase(f)
END;


FUNCTION CountTextLines(Name:STRING;VAR Lines,Cols:WORD):INTEGER;
VAR t:TEXT;
    s:STRING[255];
    IOR:INTEGER;
BEGIN
    Assign(t,Name);
    Reset(t);
    IOR:=IOResult;
    IF IOR=0 THEN
    BEGIN
        Lines:=0;
        Cols:=0;
        WHILE (IOR=0) AND NOT EOF(t) DO
        BEGIN
            ReadLn(t,s);
            IOR:=IOResult;
            INC(Lines);
            IF Length(s)>Cols THEN
                Cols:=Length(s)
        END;
        Close(t);
        IOR:=IOResult
    END;
    CountTextLines:=IOR
END;


FUNCTION GetDrive(ID:CHAR):BYTE;
VAR Regs:REGISTERS;
    i:WORD;
BEGIN
    i:=ORD(UpCase(ID));
    WITH Regs DO
    BEGIN
        AH:=$44;
        AL:=$08;
        BL:=i-64;
        Intr($21,Regs);
        CASE AL OF
             0:GetDrive:=2;
             1:GetDrive:=1
        ELSE
             GetDrive:=0
        END
    END
END;


FUNCTION WipeDir(path,wildcard:STRING):INTEGER;
VAR f:FILE;
    S:SearchRec;
    cnt,i:INTEGER;
    names:ARRAY[1..2000] OF STRING[12];
BEGIN
    IF (path='') THEN
    BEGIN
        WriteLn('WipeDir ohne Pfadangabe');
        Halt(1);
    END;
    IF (Length(path)<4) THEN
    BEGIN
        WriteLn('WipeDir auf \');
        Halt(1);
    END;
    cnt:=0;
    FindFirst(path+'\'+wildcard,$3F,S);
    WHILE DosError=0 DO
    BEGIN
        INC(cnt);
        names[cnt]:=S.Name;
        FindNext(S);
    END;
    FOR i:=1 TO cnt DO
    BEGIN
        Assign(f,path+'\'+names[i]);
        Erase(f);
    END;


END;



END.