{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O-,R-,S-,V-}
{$DEFINE PROFILERx}

UNIT Textures;

INTERFACE

USES Maths,Extragraph,SPFormat,Messages,Basis
{$IFDEF PROFILER}
     ,Profiler
{$ENDIF}
     ;

CONST maxColor=5;

TYPE ColorArray=ARRAY[1..maxColor] OF RGBfloat;

     VectorTextureFkt=PROCEDURE(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;
                                extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
     ScalarTextureFkt=FUNCTION(VAR p:Vector3;extension:POINTER):RealType;

     PVectorTexture=^VectorTexture;
     VectorTexture=OBJECT
         c:Vector3;
         m:Matrix3;

         onlyCol:BOOLEAN;       (* Nur Farbe *)
         extType:BYTE;          (* 0: siehe Fkt *)
                                (* 1: extension zeigt auf ColorMap *)
                                (* 2: build: extension1 und extension2 mitteln *)
                                (* 3: buildmax: max(Helligkeit) von extension1 und extension2 *)
                                (* 4: buildmin: min(Helligkeit) von extension1 und extension2 *)

         fkt:VectorTextureFkt;
         extension:POINTER;
         extension2:POINTER;
         part1:RealType;         (* Anteil von extension1 bei build *)
         part2:RealType;         (* Anteil von extension2 bei build *)

         colors:ColorArray;

         PROCEDURE getValues(VAR p:Vector3;VAR n:Vector3;VAR col:RGBfloat);

     END;

     PScalarTexture=^ScalarTexture;
     ScalarTexture=OBJECT
         c:Vector3;
         m:Matrix3;
         f:RealType;
         onlyF:BOOLEAN;         (* Konstanter Wert *)
         extType:BYTE;          (* 0: siehe Fkt *)
                                (* 1: ext zeigt auf ColorMap *)
         fkt:ScalarTextureFkt;
         extension:POINTER;

         FUNCTION getValue(VAR p:Vector3):RealType;

     END;

(*** Vector-Texture-Funktionen ***)
PROCEDURE VTMarble(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTMarbleN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTMarbleNN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTWater(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTChess(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTHexagon(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTHexagonN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTStruct(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTSquare(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTSquareN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTTriangle(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTTriangleN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTPlanetoid(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTPlanetoidN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTWood(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTFilm(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTFilmN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTPlatine(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTLines(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTLines2(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
PROCEDURE VTStars(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);

(*** Scalar-Texture-Funktionen ***)
FUNCTION STMarble(VAR p:Vector3;extension:POINTER):RealType;
FUNCTION STPlanetoid(VAR p:Vector3;extension:POINTER):RealType;
FUNCTION STPlatine(VAR p:Vector3;extension:POINTER):RealType;
FUNCTION STLines(VAR p:Vector3;extension:POINTER):RealType;
FUNCTION STBlur(VAR p:Vector3;extension:POINTER):RealType;
FUNCTION STBlurPlanetoid(VAR p:Vector3;extension:POINTER):RealType;


IMPLEMENTATION

TYPE R=ARRAY[0..9] OF BYTE;

CONST R1:R=( 99,178,  1, 44, 62,195, 33, 76, 54, 63);
      R2:R=( 56,255, 45, 23,111,244, 13, 58,150, 17);
      R3:R=(100,  4,  2,250, 18, 24,200, 41,155,  7);
      R4:R=( 33, 76,199,  5, 88,  2,178, 22,176, 33);

VAR i,j,k:INTEGER;
    Randoms:ARRAY[0..9,0..9,0..9] OF BYTE;


FUNCTION MarbleValue(x,y,z,GridLength:RealType):RealType;
VAR xi,yi,zi:BYTE;
    xi1,yi1,zi1:BYTE;
    xr,yr,zr,dummyr:RealType;
    GridLength2:RealType;
    h:RealType;


    PROCEDURE Index(a:RealType;VAR r:RealType;VAR i:BYTE);
    VAR ad:LONGINT;
    BEGIN
        a:=ABS(a+100000);
        ad:=TRUNC(a/GridLength);
        a:=a-GridLength*ad;
        i:=TRUNC(a/GridLength2);
        r:=(a-i*GridLength2)/GridLength2;
        i:=(i XOR ad) MOD 10;
    END;

    FUNCTION Lin(a1,a2,r:RealType):RealType;
    BEGIN
        Lin:=a1*(1-r)+a2*r
    END;


BEGIN
    GridLength2:=GridLength/10;

    Index(x,xr,xi);
    Index(y,yr,yi);
    Index(z,zr,zi);

    Index(x+GridLength2,dummyr,xi1);
    Index(y+GridLength2,dummyr,yi1);
    Index(z+GridLength2,dummyr,zi1);
    h:=Lin(Lin(Lin(Randoms[xi,yi,zi],Randoms[xi1,yi,zi],xr),
                Lin(Randoms[xi,yi1,zi],Randoms[xi1,yi1,zi],xr),
                yr),
           Lin(Lin(Randoms[xi,yi,zi1],Randoms[xi1,yi,zi1],xr),
               Lin(Randoms[xi,yi1,zi1],Randoms[xi1,yi1,zi1],xr),
               yr),
           zr)/255;



    IF h<0 THEN
        MarbleValue:=0
    ELSE IF h>1 THEN
        MarbleValue:=1
    ELSE
        MarbleValue:=h
END;

FUNCTION line(x,y:RealType;
              s1,s2,s3,s4,s5,s6,s7,s8:STRING):INTEGER;
VAR xi,yi,xii,yii,r:INTEGER;
    xx,yy:LongInt;
    s:STRING;
    c:CHAR;
    c2:BYTE;
BEGIN
    IF (ABS(x)>20000000) OR (ABS(y)>20000000) THEN
    BEGIN
        line:=0;
        Exit
    END;

    xx:=TRUNC(x)+20000000;
    yy:=TRUNC(y)+20000000;

    xi:=xx MOD 800;
    yi:=yy MOD 800;
    xii:=xi MOD 100;
    yii:=yi MOD 100;
    xi:=xi DIV 100;
    yi:=yi DIV 100;
    CASE xi OF
        0:s:=s1;
        1:s:=s2;
        2:s:=s3;
        3:s:=s4;
        4:s:=s5;
        5:s:=s6;
        6:s:=s7;
        7:s:=s8
    END;
    c:=s[SUCC(yi)];
    c2:=ORD(s[yi+9])-48;
    line:=0;
    CASE c OF
        '':IF (xii>30) AND (xii<70) OR (yii>30) AND (yii<70) THEN
                line:=c2;
        '':IF (xii>30) AND (xii<70) THEN
                line:=c2;
        '':IF (yii>30) AND (yii<70) THEN
                line:=c2;
        'O':BEGIN
                r:=(50-xii)*(50-xii)+(50-yii)*(50-yii);
                IF (r>100) AND (r<2500) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=(100-xii)*(100-xii)+yii*yii;
                IF (r>900) AND (r<4900) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=xii*xii+yii*yii;
                IF (r>900) AND (r<4900) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=(100-yii)*(100-yii)+xii*xii;
                IF (r>900) AND (r<4900) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=(100-xii)*(100-xii)+(100-yii)*(100-yii);
                IF (r>900) AND (r<4900) THEN
                    line:=c2
            END;

        '':IF (xii>15) AND (xii<85) OR (yii>15) AND (yii<85) THEN
                line:=c2;
        '':IF (xii>15) AND (xii<85) THEN
                line:=c2;
        '':IF (yii>15) AND (yii<85) THEN
                line:=c2;
        '':BEGIN
                r:=(100-xii)*(100-xii)+yii*yii;
                IF (r>225) AND (r<7225) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=xii*xii+yii*yii;
                IF (r>225) AND (r<7225) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=(100-yii)*(100-yii)+xii*xii;
                IF (r>225) AND (r<7225) THEN
                    line:=c2
            END;
        '':BEGIN
                r:=(100-xii)*(100-xii)+(100-yii)*(100-yii);
                IF (r>225) AND (r<7225) THEN
                    line:=c2
            END
    END
END;



FUNCTION PlatineValue(x,y,z:RealType):BYTE;
VAR c:BYTE;
    xs,ys:RealType;
    xx,yy:LongInt;
    xi,yi:LongInt;
    ind:LONGINT;
BEGIN
    xx:=TRUNC(x);
    yy:=TRUNC(y);

    xi:=xx DIV 800;
    yi:=yy DIV 800;

    ind:=(xi AND 3)+(yi AND 3);

    CASE ind OF
        0:
          c:=line(x,y,
                  ' O  11111111',
                  '   O O11111111',
                  'OO 11111111',
                  '       11111111',
                  'ͻ  O O11111111',
                  ' ȼO 11111111',
                  'Ŀ11111111',
                  'O   11111111');
        1:
          c:=line(x,y,
                  '    11111111',
                  '   11111111',
                  'O O O O11111111',
                  '       11111111',
                  'ͻ    11111111',
                  'O O OO 11111111',
                  'Ŀ  11111111',
                  '   11111111');
        2:
          c:=line(x,y,
                  '   11111111',
                  '   OO  11111111',
                  'O11111111',
                  '       11111111',
                  'ͼ   O11111111',
                  '        11111111',
                  'OĿ O11111111',
                  '  11111111');
        3:
          c:=line(x,y,
                  ' O  11111111',
                  ' O  O 11111111',
                  'ͼ O11111111',
                  '  O O   11111111',
                  'ͻ  O11111111',
                  ' ȼ   11111111',
                  'O O11111111',
                  ' O  11111111');
        4:
          c:=line(x,y,
                  ' O 11111111',
                  '      O11111111',
                  'O  O 11111111',
                  '  OO   11111111',
                  'O   O O11111111',
                  '   OO 11111111',
                  'OO11111111',
                  'O ٳO11111111');
        5:
          c:=line(x,y,
                  '    11111111',
                  '   11111111',
                  'O O  11111111',
                  '     11111111',
                  'ͻ  11111111',
                  ' O  11111111',
                  'O 11111111',
                  '   11111111');
        6:
          c:=line(x,y,
                  '    11111111',
                  ' O  11111111',
                  'O   O O11111111',
                  '  O    11111111',
                  'ͼ    11111111',
                  ' ĿO 11111111',
                  'O O11111111',
                  '  O11111111');
    END;
    PlatineValue:=SUCC(c)
END;

FUNCTION LinesValue(x,y,z:RealType):BYTE;
VAR c:BYTE;
    xs,ys:RealType;
    xx,yy:LongInt;
    xi,yi:LongInt;
    ind:LONGINT;
BEGIN
    xx:=TRUNC(x);
    yy:=TRUNC(y);

    xi:=xx DIV 800;
    yi:=yy DIV 800;

    ind:=(xi AND 3)+(yi AND 3);

    CASE ind OF
        0:
          c:=line(x,y,
                  '   11111111',
                  '      ɻ11111111',
                  ' ͼ11111111',
                  '       11111111',
                  'ͻ  ڿ11111111',
                  ' ȼٳ 11111111',
                  'Ŀ11111111',
                  '   11111111');
        1:
          c:=line(x,y,
                  '    11111111',
                  '   11111111',
                  ' 11111112',
                  '       11111112',
                  'ͻ    22211112',
                  'ͼ ڿ  22211111',
                  'Ŀ  11111111',
                  '   11111111');
        2:
          c:=line(x,y,
                  '   11111111',
                  '      11111111',
                  ' 21222222',
                  '       11211111',
                  'ͼ   22211112',
                  '       11111111',
                  ' Ŀ 11111111',
                  '  11111111');
        3:
          c:=line(x,y,
                  '    11111111',
                  ' ɻ    12211111',
                  'ͼ22222222',
                  '      11221111',
                  'ͻ22222222',
                  ' ȼĿ 12211111',
                  '  11111111',
                  '    11111111');
        4:
          c:=line(x,y,
                  ' ͻ11111111',
                  '      11111111',
                  'ͻ    22111112',
                  '       12111111',
                  'ͼ   22111222',
                  '    ڿ11111111',
                  'Ŀٳ11111111',
                  '  ٳ 11111111');
        5:
          c:=line(x,y,
                  '    11111111',
                  '   11111111',
                  '   11111112',
                  '    11111112',
                  'ͻ 22211112',
                  ' ڼ 11211111',
                  'ٳ 11111111',
                  '   11111111');
        6:
          c:=line(x,y,
                  '    11111111',
                  '   11111111',
                  '    11111112',
                  '    11111112',
                  'ͼ  22211112',
                  ' ڿ  11111111',
                  'ٳ 11111111',
                  '  11111111');
    END;
    LinesValue:=SUCC(c)
END;

FUNCTION Lines2Value(x,y,z:RealType):BYTE;
VAR c:BYTE;
    xs,ys:RealType;
    xx,yy:LongInt;
    xi,yi:LongInt;
    ind:LONGINT;
BEGIN
    xx:=TRUNC(x);
    yy:=TRUNC(y);

    xi:=xx DIV 800;
    yi:=yy DIV 800;

    ind:=(xi AND 3)+(yi AND 3);

    CASE ind OF
        0:
          c:=line(x,y,
                  ' ĳ   11211111',
                  '  ĳ11121111',
                  '     22112111',
                  '      11211211',
                  'ĳ  21121111',
                  '     11111121',
                  '       21111111',
                  '    11211221');
        1:
          c:=line(x,y,
                  '    21111211',
                  '     11121111',
                  ' ĳ 21121111',
                  '       12111211',
                  '  ĳ   11211111',
                  '  ĳ   11121111',
                  'ĳ 11112111',
                  '    11111111');
        2:
          c:=line(x,y,
                  ' ĳ 11212121',
                  '       11111111',
                  '     11111111',
                  ' ĳ    11111211',
                  '     11112111',
                  '     11122211',
                  'ĳ     11111111',
                  '    12211111');
        3:
          c:=line(x,y,
                  '      12221111',
                  '      11111111',
                  '      11111111',
                  '    11122122',
                  '      11111111',
                  '   ĳ 11112121',
                  'ĳ      12111111',
                  '     11112112');
        4:
          c:=line(x,y,
                  '     11212121',
                  '       11111111',
                  '  ĳ 11122111',
                  '     11211111',
                  ' ĳ    12211111',
                  '      11112211',
                  '   12211111',
                  ' ͺ   12121211');
        5:
          c:=line(x,y,
                  '    11221211',
                  'ĳ     11111111',
                  '     11122111',
                  '  ĳ   11111111',
                  '      11211111',
                  '    11111121',
                  '     11212211',
                  '    11111111');
        6:
          c:=line(x,y,
                  '   12111211',
                  '       11111111',
                  ' ĳͳĳ 11112111',
                  ' ĳ     11111111',
                  '  ĳ 11211211',
                  '       11111111',
                  ' ĳ 11111111',
                  ' ͳĳ 12112111');
    END;
    Lines2Value:=SUCC(c)
END;




PROCEDURE VectorTexture.getValues(VAR p:Vector3;VAR n:Vector3;VAR col:RGBfloat);
VAR p2:Vector3;
    outside:BOOLEAN;
    col01,col02:RGBfloat;
    n01,n02:Vector3;
    ColInt:RGBColor;
BEGIN
{$IFDEF PROFILER}
     BeginIt(7);
{$ENDIF}
    VVsub(p,c,p2);
    MVmulSelf(m,p2);
    IF onlyCol THEN
        col:=colors[1]
    ELSE IF extType>0 THEN
    BEGIN
        CASE extType OF
            1:BEGIN
                GetColMatXY(ColInt,ColMat(Extension),ROUND(p2.x),ROUND(-p2.y),outside);
                Col.r:=ColInt.r;
                Col.g:=ColInt.g;
                Col.b:=ColInt.b;
                IF outside THEN
                    col:=Colors[1]
                ELSE BEGIN
                    col.r:=Col.r*4;
                    col.g:=Col.g*4;
                    col.b:=Col.b*4
                END
              END;
            2:BEGIN
                  n01:=n;
                  n02:=n;
                  PVectorTexture(extension)^.getValues(p2,n01,col01);
                  PVectorTexture(extension2)^.getValues(p2,n02,col02);
                  col.r:=(col01.r*part1+col02.r*part2);
                  col.g:=(col01.g*part1+col02.g*part2);
                  col.b:=(col01.b*part1+col02.b*part2);
                  n.x:=(n01.x*part1+n02.x*part2);
                  n.y:=(n01.y*part1+n02.y*part2);
                  n.z:=(n01.z*part1+n02.z*part2)
              END;
            3:BEGIN
                  n01:=n;
                  n02:=n;
                  PVectorTexture(extension)^.getValues(p2,n01,col01);
                  PVectorTexture(extension2)^.getValues(p2,n02,col02);
                  IF (col01.r+col01.g+col01.b)>(col02.r+col02.g+col02.b) THEN
                  BEGIN
                      col:=col01;
                      n:=n01
                  END
                  ELSE BEGIN
                      col:=col02;
                      n:=n02
                  END
              END;
            4:BEGIN
                  n01:=n;
                  n02:=n;
                  PVectorTexture(extension)^.getValues(p2,n01,col01);
                  PVectorTexture(extension2)^.getValues(p2,n02,col02);
                  IF (col01.r+col01.g+col01.b)<(col02.r+col02.g+col02.b) THEN
                  BEGIN
                      col:=col01;
                      n:=n01
                  END
                  ELSE BEGIN
                      col:=col02;
                      n:=n02
                  END
              END;
        END
    END
    ELSE
        fkt(p2,n,m,extension,colors,col)
{$IFDEF PROFILER}
    ;EndIt(7)
{$ENDIF}
END;


FUNCTION ScalarTexture.getValue(VAR p:Vector3):RealType;
VAR p2:Vector3;
    outside:BOOLEAN;
    col:RGBColor;
BEGIN
{$IFDEF PROFILER}
     BeginIt(8);
{$ENDIF}
    VVsub(p,c,p2);
    MVmulSelf(m,p2);
    IF onlyf THEN
        getValue:=f
    ELSE IF extType>0 THEN
    BEGIN
        CASE extType OF
            1:BEGIN
                GetColMatXY(Col,ColMat(Extension),ROUND(p2.x),ROUND(-p2.y),outside);
                IF outside THEN
                    getValue:=0
                ELSE
                    getValue:=1-((col.r+col.g+col.b)/192)
              END
        END
    END
    ELSE
        getValue:=fkt(p2,extension)
{$IFDEF PROFILER}
    ;EndIt(8)
{$ENDIF}
END;


(*** Vector-Texture-Funktionen ***)

PROCEDURE VTMarble(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    h:=Sqr(Sqr(h));
    cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
    cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
    cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
END;


PROCEDURE VTMarbleN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST disNormal=0.5;
VAR h:RealType;
    nx,ny,nz:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    h:=Sqr(Sqr(h));
    cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
    cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
    cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h);

    nx:=n.x+(n.y+n.z)*h*disNormal;
    ny:=n.y+(n.z+n.x)*h*disNormal;
    nz:=n.z+(n.x+n.y)*h*disNormal;
    n.x:=nx;
    n.y:=ny;
    n.z:=nz;
    VNormSelf(n)

END;

PROCEDURE VTMarbleNN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST disNormal=1.0;
VAR h:RealType;
    nx,ny,nz:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    h:=Sqr(Sqr(h));
    cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
    cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
    cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h);

    nx:=n.x+(n.y+n.z)*h*disNormal;
    ny:=n.y+(n.z+n.x)*h*disNormal;
    nz:=n.z+(n.x+n.y)*h*disNormal;
    n.x:=nx;
    n.y:=ny;
    n.z:=nz;
    VNormSelf(n)

END;



PROCEDURE VTWater(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR l,d,s:RealType;
BEGIN
    l:=Sqrt(Sqr(p.x)+Sqr(p.z));
    d:=l*0.1;
    IF d>250 THEN
        s:=0
    ELSE
        s:=Sin(d)/(d+5)*5;
    n.y:=1;
    n.x:=p.x/l*s;
    n.z:=p.z/l*s;
    VnormSelf(n);
    cRes:=cAr[1]
END;


PROCEDURE VTChess(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:RealType;
BEGIN
    IF ODD(ROUND(p.x/500))= ODD(ROUND(p.z/500)) THEN
        cRes:=cAr[1]
    ELSE
        cRes:=cAr[2]
END;

PROCEDURE VTHexagon(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST ad=100;
      ad3=ad*3;
      brHalf=86.60254038;
      br=brHalf*2;
      st1=0.57735027; (*COS60/SIN60*)
VAR xi,yi:LONGINT;
    dx,dy:RealType;
    xx,yy:RealType;
    h:RealType;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/ad3+1000000)-1000000;
        dx:=xx-xi*br;
        dy:=yy-yi*ad3;
        yi:=yi SHL 1;
        IF dx<brHalf THEN
        BEGIN
            IF dy>ad+dx*st1 THEN
            BEGIN
                IF dy>ad3-dx*st1 THEN
                    INC(yi,2)
                ELSE
                    INC(yi)
            END;

        END
        ELSE BEGIN
            IF dy>ad+(br-dx)*st1 THEN
            BEGIN
                IF dy>ad3-(br-dx)*st1 THEN
                    INC(yi,2)
                ELSE BEGIN
                    INC(yi);
                    INC(xi)
                END
            END
        END;
        h:=MarbleValue(xi*100,yi*100,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END

END;


PROCEDURE NormalDisform(px,py:RealType;fromx,fromy,tox,toy:RealType;VAR dd:Vector3);
CONST delta=20.0;
      sqrdelta=delta*delta;
VAR dx,dy:RealType;
    p,q:RealType;
    err:BOOLEAN;
    deltad:Vector3;
    lenf:RealType;
BEGIN
    dx:=tox-fromx;
    dy:=toy-fromy;
    IF dx>dy THEN
    BEGIN
        IF (px<fromx) OR (px>tox) THEN
            Exit;
    END
    ELSE BEGIN
        IF (py<fromy) OR (py>toy) THEN
            Exit;
    END;
    lgs2(dx, dy,px-fromx,
         dy,-dx,py-fromy,
         p,q,err);
    IF err OR (p<0) OR (p>1) THEN
        EXIT;
    deltad.x:=-q*dy;
    deltad.y:=q*dx;
    deltad.z:=0;
    lenf:=SQR(deltad.x)+SQR(deltad.y);
    IF lenf>sqrdelta THEN
        EXIT;
    Vnormself(deltad);
    Vresize(deltad,1-SQRT(lenf)/delta);
    VVadd(dd,deltad,dd)
END;


PROCEDURE VTHexagonN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST ad=100;
      ad3=ad*3;
      adhalf=ad/2;
      brHalf=86.60254038;
      br=brHalf*2;
      st1=0.57735027; (*COS60/SIN60*)
      delta=20;
VAR xi,yi:LONGINT;
    dx,dy:RealType;
    xx,yy:RealType;
    h:RealType;
    dd:Vector3;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/ad3+1000000)-1000000;
        dx:=xx-xi*br;
        dy:=yy-yi*ad3;
        yi:=yi SHL 1;
        IF dx<brHalf THEN
        BEGIN
            IF dy>ad+dx*st1 THEN
            BEGIN
                IF dy>ad3-dx*st1 THEN
                    INC(yi,2)
                ELSE
                    INC(yi)
            END;

        END
        ELSE BEGIN
            IF dy>ad+(br-dx)*st1 THEN
            BEGIN
                IF dy>ad3-(br-dx)*st1 THEN
                    INC(yi,2)
                ELSE BEGIN
                    INC(yi);
                    INC(xi)
                END
            END
        END;
        dd.x:=0;
        dd.y:=0;
        dd.z:=0;
        NormalDisform(dx,dy,0,ad,brhalf,ad+adhalf,dd);
        NormalDisform(dx,dy,brhalf,ad+adhalf,br,ad,dd);
        NormalDisform(dx,dy,brhalf,ad+adhalf,brhalf,ad3-adhalf,dd);
        NormalDisform(dx,dy,0,ad3,brhalf,ad3-adhalf,dd);
        NormalDisform(dx,dy,brhalf,ad3-adhalf,br,ad3,dd);
        NormalDisform(dx,dy,0,0,0,ad,dd);
        NormalDisform(dx,dy,br,0,br,ad,dd);


        MVmulSelf(m,dd);

        n.x:=n.x+dd.x;
        n.y:=n.y+dd.y;
        n.z:=n.z+dd.z;

        VnormSelf(n);


        h:=MarbleValue(xi*100,yi*100,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END

END;


PROCEDURE VTStruct(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST br=100;
      bri=88;
VAR xii,yii,zii:LONGINT;
    xi,yi,zi:LONGINT;
    xx,yy,zz:RealType;
    h:RealType;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    zz:=p.z+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) OR (ABS(zz)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/br+1000000)-1000000;
        zi:=TRUNC(zz/br+1000000)-1000000;

        xii:=TRUNC(xx/bri+1000000)-1000000;
        yii:=TRUNC(yy/bri+1000000)-1000000;
        zii:=TRUNC(zz/bri+1000000)-1000000;


        xi:=xi XOR yii;
        yi:=yi XOR zii;
        zi:=zi XOR xii;

        h:=MarbleValue(xi,yi,zi,5);

        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END
END;



PROCEDURE VTSquare(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST br=100;
VAR xi,yi:LONGINT;
    xx,yy:RealType;
    h:RealType;
BEGIN
    xx:=p.x;
    yy:=p.y;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/br+1000000)-1000000;

        h:=MarbleValue(xi*115,yi*105,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END
END;


PROCEDURE VTSquareN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST br=100;
      delta=20;
      ff=2;
VAR xi,yi:LONGINT;
    dx,dy:RealType;
    xx,yy:RealType;
    h:RealType;
    dd:Vector3;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/br+1000000)-1000000;
        dx:=xx-xi*br;
        dy:=yy-yi*br;

        dd.x:=0;
        dd.y:=0;
        dd.z:=0;

        IF dx<delta THEN
            dd.x:=-ff*(delta-dx)/delta
        ELSE IF dx>br-delta THEN
            dd.x:=ff*(delta-(br-dx))/delta;
        IF dy<delta THEN
            dd.y:=-ff*(delta-dy)/delta
        ELSE IF dy>br-delta THEN
            dd.y:=ff*(delta-(br-dy))/delta;

        MVmulSelf(m,dd);

        n.x:=n.x+dd.x;
        n.y:=n.y+dd.y;
        n.z:=n.z+dd.z;

        VnormSelf(n);

        h:=MarbleValue(xi*115,yi*105,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END
END;



PROCEDURE VTTriangle(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST ad=86.60254038;
      brhalf=50;
      br=brhalf*2;
      st1=1.7320507765; (*SIN60/COS60*)
VAR xi,yi:LONGINT;
    dx,dy:RealType;
    xx,yy:RealType;
    h:RealType;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/ad+1000000)-1000000;
        dx:=xx-xi*br;
        dy:=yy-yi*ad;
        xi:=xi SHL 1;
        IF ODD(yi) THEN
        BEGIN
            IF dx<brHalf THEN
            BEGIN
                IF dy>dx*st1 THEN
                    DEC(xi);
            END
            ELSE BEGIN
                IF dy>(br-dx)*st1 THEN
                    INC(xi)
            END
        END
        ELSE BEGIN
            IF dx<brHalf THEN
            BEGIN
                IF dy<ad-dx*st1 THEN
                    DEC(xi);
            END
            ELSE BEGIN
                IF dy<ad-(br-dx)*st1 THEN
                    INC(xi)
            END
        END;
        h:=MarbleValue(xi*115,yi*105,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END
END;


PROCEDURE VTTriangleN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST ad=86.60254038;
      ad2=2*ad;
      brhalf=50;
      br=brhalf*2;
      st1=1.7320507765; (*SIN60/COS60*)
      delta=20;
      delta1=delta/0.8660254038;
      ff=2;
VAR xi,yi:LONGINT;
    dx,dy:RealType;
    xx,yy:RealType;
    h:RealType;
    dd:Vector3;
    ffx:RealType;
    ffd:RealType;
BEGIN
    xx:=p.x+0.01;
    yy:=p.y+0.01;
    IF (ABS(xx)>4000000) OR (ABS(yy)>4000000) THEN
        cRes:=cAr[1]
    ELSE BEGIN
        xi:=TRUNC(xx/br+1000000)-1000000;
        yi:=TRUNC(yy/ad2+1000000)-1000000;
        dx:=xx-xi*br;
        dy:=yy-yi*ad2;
        xi:=xi SHL 1;
        yi:=yi SHL 1;

        dd.x:=0;
        dd.y:=0;
        dd.z:=0;


        IF dy<ad THEN
        BEGIN
            IF dx<brHalf THEN
            BEGIN
                IF dy>dx*st1 THEN
                    DEC(xi);
            END
            ELSE BEGIN
                IF dy>(br-dx)*st1 THEN
                    INC(xi)
            END
        END
        ELSE BEGIN
            INC(yi);
            IF dx<brHalf THEN
            BEGIN
                IF dy<ad2-dx*st1 THEN
                    DEC(xi);
            END
            ELSE BEGIN
                IF dy<ad2-(br-dx)*st1 THEN
                    INC(xi)
            END
        END;

        dd.x:=0;
        dd.y:=0;
        dd.z:=0;

        NormalDisform(dx,dy,0,0,br,ad2,dd);
        NormalDisform(dx,dy,0,ad2,br,0,dd);

        NormalDisform(dx,dy,0,0,br,0,dd);
        NormalDisform(dx,dy,0,ad,br,ad,dd);
        NormalDisform(dx,dy,0,ad2,br,ad2,dd);

        MVmulSelf(m,dd);

        n.x:=n.x+dd.x;
        n.y:=n.y+dd.y;
        n.z:=n.z+dd.z;

        VnormSelf(n);


        h:=MarbleValue(xi*115,yi*105,0,500);
        cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
        cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
        cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
    END
END;



PROCEDURE VTPlanetoid(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    h:=Sqr(h);
    cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
    cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
    cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h)
END;

PROCEDURE VTPlanetoidN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST disNormal=0.5;
VAR h:RealType;
    nx,ny,nz:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    h:=Sqr(h);
    cRes.r:=(cAr[1].r*(1-h)+cAr[2].r*h);
    cRes.g:=(cAr[1].g*(1-h)+cAr[2].g*h);
    cRes.b:=(cAr[1].b*(1-h)+cAr[2].b*h);
    nx:=n.x+(n.y+n.z)*h*disNormal;
    ny:=n.y+(n.z+n.x)*h*disNormal;
    nz:=n.z+(n.x+n.y)*h*disNormal;
    n.x:=nx;
    n.y:=ny;
    n.z:=nz;
    VnormSelf(n)
END;


PROCEDURE VTWood(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST Granularity=500;
      cc1x=0.053;
      cc1z=-0.151;
      cc2x=0.278;
      cc2y=0.330;
      cc3x=-0.309;
      cc3z=0.380;

      c1x=cc1x*Granularity;
      c1z=cc1z*Granularity;
      c2x=cc2x*Granularity;
      c2y=cc2y*Granularity;
      c3x=cc3x*Granularity;
      c3z=cc3z*Granularity;


VAR d1x,d1z,d2x,d2y,d3x,d3z,r,r1,r2,r3:RealType;
    x,y,z:RealType;
    rr,rrr:LONGINT;
    ar:RealType;

    FUNCTION Convert(c:RealType):RealType;
    BEGIN
        c:=ABS(c+12345.0);
        Convert:=ABS(c-TRUNC(c/Granularity)*Granularity-Granularity/2)
    END;


BEGIN
    x:=Convert(p.x);
    y:=Convert(p.y);
    z:=Convert(p.z);
    d1x:=x-c1x;
    d1z:=z-c1z;
    r1:=Sqrt(d1x*d1x+d1z*d1z);
    d2x:=x-c2x;
    d2y:=y-c2y;
    r2:=Sqrt(d2x*d2x+d2y*d2y);
    d3x:=x-c3x;
    d3z:=z-c3z;
    r3:=Sqrt(d3x*d3x+d3z*d3z);

    r:=(r1*1.5+r2+r3)/Granularity*10;
    rr:=ROUND(r);
    rrr:=ROUND(r*5);
    ar:=ABS(r-rr);
    IF ODD(rr) THEN
    BEGIN
        IF rrr MOD 8=0 THEN
            cRes:=cAr[4]
        ELSE
          {  cRes:=cAr[1]}
        BEGIN
             cRes.r:=cAr[1].r+ROUND(ar*(cAr[3].r-cAr[1].r));
             cRes.g:=cAr[1].g+ROUND(ar*(cAr[3].g-cAr[1].g));
             cRes.b:=cAr[1].b+ROUND(ar*(cAr[3].b-cAr[1].b))
        END
    END
    ELSE IF rr MOD 8>0 THEN
      {  cRes:=cAr[2] }
    BEGIN
        cRes.r:=cAr[2].r+ROUND(ar*(cAr[1].r-cAr[2].r));
        cRes.g:=cAr[2].g+ROUND(ar*(cAr[1].g-cAr[2].g));
        cRes.b:=cAr[2].b+ROUND(ar*(cAr[1].b-cAr[2].b))
    END
    ELSE
        cRes:=cAr[3]
END;


PROCEDURE VTFilm(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST refr=1.5;
      refrRez=1/refr;
      c1=0.00100;
      c2=0.00110;
      c3=0.00130;
      Granularity=500;
VAR h:RealType;
    RRR:RealType;
    Theta:RealType;
    d:RealType;
BEGIN
    VNormSelf(n);
    Theta:=arccos((n.x+n.y+n.z)*0.57735);
    d:=0.01+MarbleValue(p.x,p.y,p.z,Granularity)*0.01;

    RRR:=2*refr*d*cos(arcsin(sin(Theta)*refrRez));

    cRes.r:=(100*(sin(RRR/c1))+155);
    cRes.g:=(100*(sin(RRR/c2))+155);
    cRes.b:=(100*(sin(RRR/c3))+155)
END;


PROCEDURE VTFilmN(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST refr=1.5;
      refrRez=1/refr;
      c1=0.00100;
      c2=0.00110;
      c3=0.00130;
      Granularity=500;
      disNormal=0.2;
VAR h:RealType;
    RRR:RealType;
    Theta:RealType;
    d:RealType;
    nx,ny,nz:RealType;
BEGIN
    VNormSelf(n);
    Theta:=arccos((n.x+n.y+n.z)*0.57735);
    d:=0.01+MarbleValue(p.x,p.y,p.z,Granularity)*0.01;

    RRR:=2*refr*d*cos(arcsin(sin(Theta)*refrRez));

    nx:=n.x+(n.y+n.z)*sin(RRR/c1)*disNormal;
    ny:=n.y+(n.z+n.x)*sin(RRR/c2)*disNormal;
    nz:=n.z+(n.x+n.y)*sin(RRR/c3)*disNormal;
    n.x:=nx;
    n.y:=ny;
    n.z:=nz;
    VnormSelf(n);

    cRes:=cAr[1]
END;




PROCEDURE VTStars(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
CONST cub=4;            {6}
      Granularity=35000; {50000}
      rMax=1.2*Granularity*Granularity/3135;
VAR x,y,z:RealType;
    r,sx,sy,sz:RealType;
    i,j,k:INTEGER;

    FUNCTION Convert(c:RealType):RealType;
    BEGIN
        c:=ABS(c+20000);
        Convert:=ABS(c-TRUNC(c/Granularity)*Granularity)
    END;

BEGIN

    x:=Convert(p.x);
    y:=Convert(p.y);
    z:=Convert(p.z);

    FOR i:=0 TO Cub DO
        FOR j:=0 TO Cub DO
            FOR k:=0 TO Cub DO
            BEGIN
                sx:=(Randoms[i,j,k+0]/255*Granularity);
                sy:=(Randoms[i,j,k+1]/255*Granularity);
                sz:=(Randoms[i,j,k+2]/255*Granularity);
                r:=Sqr(x-sx)+Sqr(y-sy)+Sqr(z-sz);
                IF r<rMax THEN  {800000}
                BEGIN
                    cRes.r:=255-i*7;
                    cRes.g:=255-j*7;
                    cRes.b:=255-k*7;
                    Exit
                END
        END;

    cRes.r:=0;
    cRes.g:=0;
    cRes.b:=0

END;


PROCEDURE VTPlatine(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:BYTE;
BEGIN
    h:=PlatineValue(p.x,p.y,p.z);
    cRes:=cAr[h]
END;



PROCEDURE VTLines(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:BYTE;
BEGIN
    h:=LinesValue(p.x,p.y,p.z);
    cRes:=cAr[h]
END;


PROCEDURE VTLines2(VAR p:Vector3;VAR n:Vector3;VAR m:Matrix3;extension:POINTER;VAR cAr:ColorArray;VAR cRes:RGBfloat);
VAR h:BYTE;
BEGIN
    h:=Lines2Value(p.x,p.y,p.z);
    cRes:=cAr[h]
END;


(*** Scalar-Texture-Funktionen ***)

FUNCTION STMarble(VAR p:Vector3;extension:POINTER):RealType;
VAR h:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    STMarble:=Sqr(Sqr(h))
END;

FUNCTION STPlanetoid(VAR p:Vector3;extension:POINTER):RealType;
VAR h:RealType;
BEGIN
    h:=MarbleValue(p.x,p.y,p.z,500);
    STPlanetoid:=Sqr(h)
END;


FUNCTION STPlatine(VAR p:Vector3;extension:POINTER):RealType;
VAR h:BYTE;
BEGIN
    h:=PlatineValue(p.x,p.y,p.z);
    IF h=1 THEN
        STPlatine:=0
    ELSE
        STPlatine:=0.8
END;

FUNCTION STLines(VAR p:Vector3;extension:POINTER):RealType;
VAR h:BYTE;
BEGIN
    h:=LinesValue(p.x,p.y,p.z);
    IF h=1 THEN
        STLines:=0
    ELSE
        STLines:=0.8
END;


FUNCTION STBlur(VAR p:Vector3;extension:POINTER):RealType;
CONST ZeroBlur=2000;
VAR h:RealType;
BEGIN
    h:=(-p.x-p.y-p.z);
    IF h<0 THEN
        STBlur:=1
    ELSE IF h>ZeroBlur THEN
        STBlur:=0
    ELSE
        STBlur:=1-h/ZeroBlur
END;

FUNCTION STBlurPlanetoid(VAR p:Vector3;extension:POINTER):RealType;
CONST ZeroBlur=500;
VAR h,b:RealType;
BEGIN
    h:=(-p.z);
    IF h<0 THEN
        b:=1
    ELSE IF h>ZeroBlur THEN
        b:=0
    ELSE
        b:=1-h/ZeroBlur;

    h:=MarbleValue(p.x,p.y,p.z,500);
    STBlurPlanetoid:=Sqr(h)*b

END;


BEGIN
    FOR i:=0 TO 9 DO
        FOR j:=0 TO 9 DO
            FOR k:=0 TO 9 DO
                Randoms[i,j,k]:=BYTE(((WORD(R1[i])+R2[j]+R3[k]) XOR R4[(i+j+k) MOD 10]) AND 255);

END.
